Package: predicts
Type: Package
Title: Spatial Prediction Tools
Description: Methods for spatial predictive modeling, especially for spatial distribution models. This includes algorithms for model fitting and prediction, as well as methods for model evaluation. 
Version: 0.2-2
Date: 2026-04-29
Depends: R (>= 3.5.0), methods, terra
Encoding: UTF-8
Suggests: disdat, rJava
Authors@R: c(
	person("Robert J.", "Hijmans", role = c("cre", "aut"),  
			email = "r.hijmans@gmail.com", comment = c(ORCID = "0000-0001-5872-2872")),
	person("Steven", "Phillips", role = "ctb"),
	person("Márcia", "Barbosa", role = "ctb"),	
	person("Chris", "Brunsdon", role = "ctb"),
	person("Barry", "Rowlingson", role = "ctb"))
Maintainer: Robert J. Hijmans <r.hijmans@gmail.com>
License: GPL (>= 3)
LazyLoad: yes
URL: https://rspatial.org/sdm/
BugReports: https://github.com/rspatial/predicts/issues/
NeedsCompilation: no
Packaged: 2026-04-29 10:07:38 UTC; rhijm
Author: Robert J. Hijmans [cre, aut] (ORCID:
    <https://orcid.org/0000-0001-5872-2872>),
  Steven Phillips [ctb],
  Márcia Barbosa [ctb],
  Chris Brunsdon [ctb],
  Barry Rowlingson [ctb]
Repository: CRAN
Date/Publication: 2026-04-29 11:00:02 UTC
Built: R 4.6.0; ; 2026-05-01 20:16:04 UTC; unix

# Author: Robert Hijmans
# January 2010
# License GPL3

folds <- function(x, k=5, by=NULL) {

	singlefold <- function(obs, k) {
		if (k==1) {
			return(rep(1, obs))
		} else {
			i <- obs / k
			if (i < 1) {
				stop('insufficient records:', obs, ', with k=', k)
			}
			i <- round(c(0, i * 1:(k-1), obs))
			times = i[-1] - i[-length(i)]

			group <- c()
			for (j in 1:(length(times))) {
				group <- c( group, rep(j, times=times[j]) )
			}
		
			r <- order(stats::runif(obs))
			return(group[r]) 
		}
	}

	if (is.vector(x)) {
		if (length(x) == 1) {
			if (x > 1) {
				x <- 1:x
			}
		}
		obs <- length(x)
	} else {
		obs <- nrow(x)
	}
	if (is.null(by)) {
		return(singlefold(obs, k))
	}
	
	by = as.vector(as.matrix(by))
	if (length(by) != obs) {
		stop('by should be a vector with the same number of records as x')
	}
	un <- unique(by)
	group <- vector(length=obs)
	for ( u in un ) {
		i = which(by==u)
		kk = min(length(i), k)
		if (kk < k) warning('lowered k for by group: ', u  ,'  because the number of observations was  ',  length(i))
		group[i] <- singlefold(length(i), kk)
	} 
	return(group)
}

setClass("SDM",
	contains = "VIRTUAL",
	representation (
		presence = "data.frame",
		absence = "data.frame",
		hasabsence = "logical"
	),	
	prototype (	
		hasabsence = FALSE
	),
	validity = function(object)	{
		(ncol(object@presence) == 2) && (ncol(object@absence) == 2)
	}
)	



setMethod ("show" , "SDM", 
	function(object) {
		cat("class    :" , class(object), "\n")
		cat("variables:", colnames(object@presence), "\n")
		pp <- nrow(object@presence)
		cat("presence points:", pp, "\n")
		if (pp < 10) {
			print(object@presence)
		} else {
			print(object@presence[1:6,])
			cat("      ... \n")
		}
		if (object@hasabsence) {
			pp <- nrow(object@absence)
			cat("\nabsence points:", pp, "\n")
			if (pp < 10) {
				print(object@absence)
			} else {
				print(object@absence[1:10,])
				cat("  (... ...  ...)\n\n")
			}
		}
	}
)	

# Author: Robert J. Hijmans
# Date :  December 2009
# Version 0.1
# Licence GPL v3


RMSE <- function(obs, prd, na.rm=FALSE) {
	sqrt(mean((obs - prd)^2, na.rm=na.rm))
}

RMSE_null <- function(obs, prd, na.rm=FALSE) {
	r <- RMSE(obs, prd, na.rm=na.rm)
	null <- RMSE(obs, mean(obs))
	(null - r) / null
}



.auctest <- function(p, a) {
	w <- stats::wilcox.test(p, a)
	pauc <- w$p.value
	auc <- as.vector(w$statistic) / (length(a) * length(p))
	cbind(auc, pauc)
}



setClass("paModelEvaluation",
	representation (
		presence = "vector",
		absence = "vector",
		confusion = "matrix",
		stats = "data.frame",
		tr_stats = "data.frame",
		thresholds = "data.frame"
	)
)



pa_evaluate <- function(p, a, model=NULL, x=NULL, tr, ...) {
	if (!is.null(model)) {
		if (is.null(x)) {
			p <- predict(model, p, ...)
			a <- predict(model, a, ...)
		} else {
			p <- terra::extract(x, p)
			p <- predict(model, p, ...)
			a <- terra::extract(x, a)
			a <- predict(model, a, ...)
		}
	}
	p <- as.numeric(stats::na.omit(p))
	a <- as.numeric(stats::na.omit(a))
	np <- length(p)
	na <- length(a)
	if (na == 0 | np == 0) {
		stop("cannot evaluate a model without absence and presence data that are not NA")
	}

	if (missing(tr)) {
		if (length(p) > 1000) {
			tr <- as.vector(stats::quantile(p, 0:1000/1000))
		} else {
			tr <- p
		}
		if (length(a) > 1000) {
			tr <- c(tr, as.vector(stats::quantile(a, 0:1000/1000)))
		} else {
			tr <- c(tr, a)
		}
		tr <- sort(unique( round(tr, 8)))
		tr <- c( tr - 0.0001, tr[length(tr)] + c(0, 0.0001))
	} else {
		tr <- sort(as.vector(tr))
	}
	
	N <- na + np

	xc <- methods::new("paModelEvaluation")
	xc@presence = p
	xc@absence = a
		
	R <- sum(rank(c(p, a))[1:np]) - (np*(np+1)/2)
	auc <- R / (as.numeric(na) * as.numeric(np))
	
	cr <- try( stats::cor.test(c(p,a), c(rep(1, length(p)), rep(0, length(a))) ), silent=TRUE )
	corc <- pcor <- NA
	if (!inherits(cr, "try-error")) {
		corc <- cr$estimate
		pcor <- cr$p.value
	} 
	
	res <- matrix(ncol=4, nrow=length(tr))
	colnames(res) <- c("tp", "fp", "fn", "tn")
	for (i in 1:length(tr)) {
		res[i,1] <- length(p[p>=tr[i]])  # a  true positives
		res[i,2] <- length(a[a>=tr[i]])  # b  false positives
		res[i,3] <- length(p[p<tr[i]])    # c  false negatives
		res[i,4] <- length(a[a<tr[i]])    # d  true negatives
	}
	xc@confusion = res
	a = res[,1]
	b = res[,2]
	c = res[,3]
	d = res[,4]
# after Fielding and Bell	
	np <- as.integer(np)
	na <- as.integer(na)
	prevalence = (a[1] + c[1]) / N
 # overall diagnostic power
	ODP = (b[1] + d[1]) / N
	xc@stats <- data.frame(np, na, prevalence, auc, cor=corc, pcor, ODP)
	rownames(xc@stats) <- NULL
 # correct classification rate
	CCR = (a + d) / N
 # sensitivity, or true positive rate
	TPR = a / (a + c)
 # specificity, or true negative rate
	TNR = d / (b + d)
 # False positive rate
	FPR = b / (b + d)
 # False negative rate
	FNR = c/(a + c)
	PPP = a/(a + b)
	NPP = d/(c + d)
 # misclassification rate
	MCR = (b + c)/N
 # odds ratio
	OR = (a*d)/(c*b)

	prA = (a+d)/N
	prY = (a+b)/N * (a+c)/N
	prN = (c+d)/N * (b+d)/N
	prE = prY + prN
	kappa = (prA - prE) / (1-prE)
	xc@tr_stats <- data.frame(treshold=tr, kappa, CCR, TPR, TNR, FPR, FNR, PPP, NPP, MCR, OR)



	max_kappa <- tr[which.max(kappa)]
	# maximum sum of the sensitivity (true positive rate) and specificity (true negative rate)
	max_spec_sens <- tr[which.max(TPR + TNR)]
	# no omission
	no_omission <- tr[max(which(res[, "fn"] == 0))]
	# Suggestions by Diego Nieto-Lugilde		
	# equal prevalence
	equal_prevalence = tr[which.min(abs(tr - prevalence))] 
	# equal sensitivity and specificity
	equal_sens_spec <- tr[which.min(abs(TPR - TNR))]
		
	xc@thresholds <- data.frame(max_kappa, max_spec_sens, no_omission,  equal_prevalence, equal_sens_spec)

	return(xc)
}


setMethod ("show" , "paModelEvaluation", 
	function(object) {
		cat("@stats\n")
		print(round(object@stats, 3))
		cat("\n")
		cat("@thresholds\n")
		print(round(object@thresholds, 3))
		cat("\n")
		cat("@tr_stats\n")
		x <- rbind(head(object@tr_stats, 4), tail(object@tr_stats, 3))
		x <- round(x, 2)
		x[4, ] <- "..."
		print(x)		
	}
)	





setMethod ("show" , "paModelEvaluation", 
	function(object) {
		cat("@stats\n")
		print(round(object@stats, 3))
		cat("\n")
		cat("@thresholds\n")
		print(round(object@thresholds, 3))
		cat("\n")
		cat("@tr_stats\n")
		x <- rbind(head(object@tr_stats, 4), tail(object@tr_stats, 3))
		x <- round(x, 2)
		x[4, ] <- "..."
		print(x)		
	}
)	



setMethod("plot", signature(x="paModelEvaluation"), 
	function(x, y="ROC", col="red", ...) {
		if (y == "boxplot") {
			prediction <- c(x@presence, x@absence)
			group <- c(rep("presence", length(x@presence)), rep("absence", length(x@absence)) )
			boxplot(prediction~group, data=data.frame(prediction, group), ...)
		} else if (y == "ROC") {
			txt = paste("AUC=", round(x@stats$auc,3))
			plot(x@tr_stats$FPR, x@tr_stats$TPR, xlim=c(0,1), ylim=c(0,1), xlab="False postive rate", ylab="True positive rate", col=col, main=txt, ...)
			lines(x@tr_stats$FPR, x@tr_stats$TPR, col=col)
			lines(rbind(c(0,0), c(1,1)), lwd=2, col="grey")
		} else if (y == "density") {
			pr <- density(x@presence)
			ab <- density(x@absence, bw=pr$bw )
			yl = c(min(ab$y, pr$y), max(ab$y, pr$y))
			xl = c(min(x@tr_stats$treshold), max(x@tr_stats$treshold))
			plot(ab, main="", ylab=paste("Density. Bandwidth=",round(pr$bw,5),paste=""), xlab="predicted value", xlim=xl, ylim=yl, lwd=2, lty=2, col="blue", ...)
			lines(pr, col="red", lwd=2)
		} else if (y %in% colnames(x@tr_stats)) {
			dat <- x@tr_stats[, y]
			#mx = x@tr_stats$treshold[which.max(dat)]
			#mn = x@tr_stats$treshold[which.min(dat)]
			plot(x@tr_stats$treshold, dat, xlab="threshold", ylab=y, ...)
			lines(x@tr_stats$treshold, dat, col=col)
		} else {
			stop("invalid option")
		}
	}	
)


if (!isGeneric("threshold")) {
	setGeneric("threshold", function(x, ...)
		standardGeneric("threshold"))
}	


setMethod('threshold', signature(x='paModelEvaluation'),
	function(x) {
		x@thresholds
	}
)




cm_evaluate <- function(cmat, stat="overall") {

	stopifnot(stat %in% c("kappa", "overall", "class"))
	n <- sum(cmat)
	d <- diag(cmat)
	if (stat == "kappa") {
		# observed (true) cases per class
		p <- rowSums(cmat) / n 
		# predicted cases per class
		q <- colSums(cmat) / n 
		expAccuracy <- sum(p*q)
		OA <- sum(d) / n
		kappa <- (OA - expAccuracy) / (1 - expAccuracy)
		return(kappa)
	} else if (stat == "overall") {
		OA <- sum(d) / n
		return(OA)
	} else if (stat == "class") {
		rw <- d / rowSums(cmat) 
		cw <- d / colSums(cmat) 
		x <- rbind(rw, cw)
		rownames(x) <- c("row-wise", "col-wise")
		return(x)
	}
}

# Author: Robert J. Hijmans
# Date : December 2009
# Version 1.0
# Licence GPL v3


if (!isGeneric("envelope")) {
	setGeneric("envelope", function(x, ...)
		standardGeneric("envelope"))
}	


setClass("envelope_model",
	contains = "SDM",
	representation (
		min = "numeric",
		max = "numeric",
		factor = "list",
		names = "character"
	),	
	validity = function(object)	{
		return(TRUE)
	}
)


setMethod("envelope", signature(x="matrix"), 
	function(x, ...) {
		envelope(data.frame(x), ...)
	}
)

setMethod("envelope", signature(x="data.frame"), 
	function(x, ...) {
		n <- ncol(x)
		nv <- 0
		nms <- NULL
		bc <- new("envelope_model")
		datatype <- sapply(x, class)
		i <- (datatype == "factor" | datatype == "character")
		if (any(i)) {
			y <- x[,i,drop=FALSE]
			x <- x[,!i,drop=FALSE]
			y <- lapply(y, function(i) as.character(as.vector(stats::na.omit(i))))
			y <- y[sapply(y, length) > 0]
			if (length(y) > 0) { 
				y <- lapply(y, function(i) { 
					i <- as.data.frame(table(i))
					i[,2] <- i[,2]/max(i[,2])
					i
				})	
				nv <- length(y)
				nms <- names(y)
				bc@factor <- y
			}
		}
		haveNumeric = ncol(x) > 0
		if (haveNumeric) {
			x <- lapply(x, function(i) as.vector(stats::na.omit(i)))
			x <- x[sapply(x, length) > 1]
			nv <- nv + length(x)
			nms <- c(names(x), nms)
			bc@min <- sapply(x, min)
			bc@max <- sapply(x, max)
			bc@presence <- data.frame(x)
		}
		if (nv == 0) {
			stop("no variables with sufficient data")
		}
		if (nv < n) {
			warning("variables with insufficient data were removed")
		}
		bc@names <- nms
		bc
	}
)

setMethod("envelope", signature(x="SpatRaster"), 
	function(x, p, ...) {
		m <- extract(x, p, ID=FALSE)
		envelope(data.frame(m), ...)
	}
)

#bc <- envelope(d)

setMethod("show", signature(object="envelope_model"), 
	function(object) {
		utils::str(object)
	}
)






.percRank <- function(x, y, tail) {
	x <- sort(x)
	b <- apply(y, 1, FUN=function(z)sum(x<z))
	t <- apply(y, 1, FUN=function(z)sum(x==z))
	r <- (b + 0.5 * t)/length(x)
	
	if (tail=="both") {
		i <- which(r > 0.5)
		r[i] <- 1-r[i]
	} else if (tail == "high") {
		r[ r < 0.5 ] <- 0.5
		r <- 1-r
	} else { # if tail == "low"
		r[ r > 0.5 ] <- 0.5
	}
	r * 2
}


.envelope_predict <- function(object, tails, mincomp, maxcomp, xn, xf=NULL) {
	bc <- matrix(0, ncol=ncol(xn), nrow=nrow(xn))
	na <- apply(is.na(xn), 1, any)
	bc[na,] <- NA
	k <- apply(t(xn) >= mincomp, 2, all) & apply(t(xn) <= maxcomp, 2, all)
	k[na] <- FALSE
	nms <- colnames(xn)
	for (i in 1:ncol(bc)) {
		bc[k,i] <- .percRank(object@presence[[ nms[i] ]], xn[k, nms[i], drop=FALSE], tails[i])
	}
	return( apply(bc, 1, min) )
}


setMethod("predict", signature(object="envelope_model"), 
function(object, x, tails=NULL, ext=NULL, filename="", ...) {

	ln <- object@names

	if (is.null(tails) ) {
		tails <- rep("both", times=length(ln))
	} else {
		stopifnot(all(tails %in% c("low", "high", "both")))
		if (length(tails) == 1) {
			tails <- rep(tails, length(ln))
		} else if (length(tails) != length(ln)) {
			stop('length of "tails" is: ', length(tails), '.\nThis does not match the number of variables in the model which is: ', length(ln))
		}
	}
	mincomp <- object@min
	mincomp[tails=="high"] <- -Inf
	maxcomp <- object@max
	maxcomp[tails=="low"] <- Inf

	if (! all(ln %in% names(x)) ) {
		stop("missing variables in x")
	}
	
	if (! (inherits(x, "SpatRaster")) ) {
		x <- x[, ln ,drop=FALSE]
		return(.envelope_predict(object, tails, mincomp, maxcomp, x))

	} else {
		if ((length(ln) < length(x))) {
			x <- x[[ln]]
		}
		if (!is.null(ext)) {
			x <- terra::crop(x, ext)
		}
		out <- terra::rast(x, nlyr=1)
		names(out)  <- "envelope"
		ncols <- terra::ncol(out)
		terra::readStart(x)
		on.exit(terra::readStop(x))
		b <- terra::writeStart(out, filename, ...)
		for (i in 1:b$n) {
			rowvals <- terra::readValues(x, b$row[i], b$nrows[i], 1, ncol(x), TRUE, FALSE)
			p <- .envelope_predict(object, tails, mincomp, maxcomp, rowvals)
			terra::writeValues(out, p, b$row[i], b$nrows[i])
		}
		terra::writeStop(out)
		return(out)
	}
}
)


setMethod("plot", signature(x="envelope_model", y='missing'), 
	function(x, a=1, b=2, p=0.9, ocol="gray", icol="red", bcol="blue", cex=c(0.6, 0.6), ...) {
			
		myquantile <- function(x, p) {
			p <- min(1, max(0, p))
			x <- sort(as.vector(stats::na.omit(x)))
			if (p == 0) return(x[1])
			if (p == 1) return(x[length(x)])
			i = (length(x)-1) * p + 1
			ti <- trunc(i)
			below = x[ti]
			above = x[ti+1]
			below + (above-below)*(i-ti)  
		}
	
		p <- min(1,  max(0, p))
		if (p > 0.5) p <- 1 - p
		p <- p / 2
		d <- x@presence
		prd <- predict(x, d)
		i <- prd > p & prd < (1-p)
		if (is.character(a)) xlab <- a else xlab <- colnames(d)[a]
		if (is.character(b)) ylab <- b else ylab <- colnames(d)[b]
		plot(d[,a], d[,b], xlab=xlab, ylab=ylab, cex=0, type="n")
		type <- 6
		x1 <- quantile(d[,a], probs=p, type=type)	
		x2 <- quantile(d[,a], probs=1-p, type=type)	
		y1 <- quantile(d[,b], probs=p, type=type)	
		y2 <- quantile(d[,b], probs=1-p, type=type)	
#		x1 <- myquantile(x[,a], p)	
#		x2 <- myquantile(x[,a], 1-p)	
#		y1 <- myquantile(x[,b], p)	
#		y2 <- myquantile(x[,b], 1-p)
		cex <- rep_len(cex, 2)
		points(d[!i,a], d[!i,b], col=ocol, pch=3, cex=cex[1])
		points(d[i,a], d[i,b], xlab=colnames(x)[a], ylab=colnames(x)[b], col=icol, cex=cex[2])
		graphics::polygon(rbind(c(x1,y1), c(x1,y2), c(x2,y2), c(x2,y1), c(x1,y1)), border=bcol, lwd=2)
	}
)

# adapted from from R package pycno
# Chris Brunsdon <christopher.brunsdon at nuim.ie>
# GPL >= 2


# x = SpatRaster
# v = SpatVector 
# pop = field in v, or vector
  
pycnophy <- function(x, v, pop, r=0.2, converge=3, verbose=FALSE) {


		s1d <- function(s) unclass(stats::filter(s, c(0.5,0,0.5)))

		pycno <- function(x, r, zones, uzones, pops) {
			mval <- mean(x)
			pad <- rbind(mval, cbind(mval, x, mval), mval)
			pad <- (t(apply(pad, 1, s1d)) + apply(pad, 2, s1d))/2
			pad <- pad[2:(nrow(x)+1), 2:(ncol(x)+1)]
			x <- x * r + (1-r) * pad
			for (i in uzones) {
				z <- (zones == i)
				x[z] <- pmax(0, x[z] * pops[i]/sum(x[z]))
				x[z] <- x[z] + (pops[i] - sum(x[z]))/sum(z)
			}
			x
		}


	# prep data 
		if (is.character(pop)) {
			stopifnot(pop %in% names(v))
			pop <- v[[pop, drop=TRUE]]
		} else {
			stopifnot(length(pop) == nrow(v))
		}
		pop <- pmax(0, pop)
#		i <- pop > 0
#		i[is.na(i)] <- FALSE
#		if (!all(i)) {
#			if (any(i)) {
#				v <- v[i,]
#				pop <- pop[i]
#			} else {
#				stop("none of the values in 'pop' is larger than zero")
#			}
#		}

	# add zero for NAs
		pops <- c(pop, 0)

	# zones
		x <- rasterize(v, x, 1:nrow(v))
		zones <- t(as.matrix(x, wide=TRUE))
		zones[is.na(zones)] <- max(zones, na.rm=TRUE)+1
		uzs <- sort(unique(as.vector(zones)))
	   
	# pop per cell
		xx <- zones*0
		for (i in uzs) {
			zone.set <- (zones == i)
			xx[zone.set] <- pops[i]/sum(zone.set)
		}

		stopper <- max(xx, na.rm=TRUE) * 10^(-converge)
		repeat {
			old.x <- xx
			xx <- pycno(xx, r, zones, uzs, pops)
			if (verbose) {
				cat(sprintf("Maximum Change: %12.5f - will stop at %12.5f\n", max(abs(old.x - xx)), stopper))
				utils::flush.console()
			}
			if (max(abs(old.x - xx), na.rm=TRUE) < stopper) break 
		}
	y <- setValues(x, as.vector(xx))
	mask(y, x)
} 

# Author: Robert J. Hijmans, r.hijmans@gmail.com
# Date : April 2011
# Version  1.0
# Licence GPL v3


pwd_sample <- function(fixed, sample, reference, tr=0.33, nearest=TRUE, n=1, lonlat=TRUE, warn=TRUE) {

	distHaversine <- function (p1, p2) {
		r <- 6378137
		toRad <- pi/180
		p1 <- p1 * toRad
		p2 <- p2 * toRad
		p <- cbind(p1[, 1], p1[, 2], p2[, 1], p2[, 2])
		dLat <- (p[, 4] - p[, 2])
		dLon <- (p[, 3] - p[, 1])
		a <- sin(dLat/2) * sin(dLat/2) + cos(p[, 2]) * cos(p[, 4]) * sin(dLon/2) * sin(dLon/2)
		dist <- 2 * atan2(sqrt(a), sqrt(1 - a)) * r
		as.vector(dist)
	}

	distGeo <- function (x, y) {
		n <- nrow(x)
		m <- nrow(y)
		dm <- matrix(ncol = m, nrow = n)
		for (i in 1:n) {
			dm[i, ] <- distHaversine(x[i, ,drop=FALSE], y)
		}
		return(dm)
	}
	
	
	distPlane <- function (x, y) {
		dfun <- function(x, y) {
			sqrt( (x[,1] - y[,1])^2 + (x[,2] - y[,2])^2 )
		}
		n = nrow(x)
		m = nrow(y)
		dm = matrix(ncol = m, nrow = n)
		for (i in 1:n) {
			dm[i, ] = dfun(x[i, ,drop=FALSE], y)
		}
		return(dm)
	}
	
	if (lonlat) {
		distfun <- distGeo
	} else {
		distfun <- distPlane
	}
	
	stopifnot(tr > 0)
	
	n <- round(n)
	stopifnot(n >= 1)
	
	if (inherits(fixed, 'SpatVector')) fixed <- crds(fixed)
	if (inherits(sample, 'SpatVector')) sample <- crds(sample)
	if (inherits(reference, 'SpatVector')) reference <- crds(reference)
	fixed     <- as.matrix(fixed)[,1:2]
	sample    <- as.matrix(sample)[,1:2]
	reference <- as.matrix(reference)[,1:2]

	if (warn) {
		if (nrow(sample) < nrow(fixed)) {
			warning("nrow(sample) < nrow(fixed)")
		}
	}
	
	fromd <- apply(distfun(fixed, reference), 1, min)
	tod <- apply(distfun(sample, reference), 1, min)

	ngb <- matrix(NA, nrow=length(fromd), ncol=n)

	iter <- sample(1:nrow(fixed)) # random order
	
	for (j in 1:n) {
		for (i in iter) {
			d <- abs(tod - fromd[i])
			if (min(d) < (tr * fromd[i])) {
				if (nearest) {
					x <- which.min(d)
				} else {
					x <- sample(which(d < (tr * fromd[i])), size=1) 
				}
				ngb[i, j] <- x
				tod[x] <- Inf
			} 
		}
	}
	return(ngb)
}

# Author: Robert Hijmans
# January 2010
# License GPL3

.get_model_data <- function(m) {
	if (inherits(m, "lm") || inherits(m, "glm")) {
		rvar <- as.character(attributes(m$terms)$variables[[2]])
		m <- m$model
		m[, !(names(m) %in% rvar), drop=FALSE]
	} else if (inherits(m, "SDM")) {
		rbind(m@presence, m@absence)
	} else {
		NULL
	}
}

.get_response_data <- function(m) {
	if (inherits(m, "lm") || inherits(m, "glm")) {
		rvar <- as.character(attributes(m$terms)$variables[[2]])
		m$model[,rvar]
	} else if (inherits(m, "SDM")) {
		c(rep(1, nrow(m@presence)), rep(0, nrow(m@absence)))
	} else {
		NULL
	}
}


varImportance <- function(model, y, x, n=10, stat, value="relative", ...) {

#	vars <- vars[vars %in% colnames(x)]
#	if (length(vars) < 1) {
#		stop("no valid names in vars")
#	}
	
	value <- match.arg(tolower(value), c("absolute", "relative", "difference"))
	
	if (missing(x)) {
		x <- .get_model_data(model)
		if (is.null(x)) {
			stop("data argument cannot be missing when using this model type")
		}
	}
	vars <- colnames(x)
	eva <- matrix(nrow=n, ncol=length(vars))
	colnames(eva) <- vars

	
	if (missing(y)) {
		y <- .get_response_data(model)
		if (is.null(y)) {
			message("computing response (y) from x")
			y <- predict(model, x, ...)
		}
	}

	P <- predict(model, x, ...)
	if (is.factor(P)) {
		if (missing(stat)) stat = "overall"
		stopifnot(stat %in% c("overall", "kappa"))
		efun <- function(y, x) {
			tab <- table(x, y)
			1 - cm_evaluate(tab, stat)
		}
	} else {
		if (missing(stat)) stat = "RMSE"
		stopifnot(stat %in% c("RMSE", "AUC", "cor"))
		if (stat == "AUC") {
			efun <- function(y, x) {
				i <- y == 1
				1 - pa_evaluate(x[i], x[!i])@stats$auc
			}
		} else if (stat == "cor"){
			efun <- function(y, x) {
				i <- y == 1
				1 - pa_evaluate(x[i], x[!i])@stats$cor
			}
		} else {
			efun <- predicts::RMSE
		}
	}

	base <- efun(y, P)

	for (i in 1:length(vars)) {
		rd <- x
		v <- vars[i]
		for (j in 1:n) {
			rd[[v]] <- sample(rd[[v]])
			p <- predict(model, rd, ...)
			eva[j,i] <- efun(y, p)
		}
	}
	if (value == "relative") {
		(colMeans(eva) - base) / base
	} else if (value == "absolute") {
		colMeans(eva)
	} else { #"difference"
		colMeans(eva) - base
	}
}


.pnrnc <- function(nr, nc, nl) {
	if (missing(nc)) {
		nc <- ceiling(sqrt(nl))
	} else {
		nc <- max(1, min(nl, round(nc)))
	}
	if (missing(nr)) {
		nr <- ceiling(nl / nc)
	} else {
		nr <- max(1, min(nl, round(nr)))
		nc <- ceiling(nl / nr)
	}
	c(nr, nc)
}


partialResponse <- function(model, data, var=NULL, rng=NULL, nsteps=25, plot=TRUE, nr, nc, ...) {

	if (missing(data)) {
		data <- .get_model_data(model)
		if (is.null(data)) {
			stop("data argument cannot be missing when using this model type")
		}
	}
	
	if (is.null(var)) {
		var <- names(data)
	} else if (is.numeric(var)) {
		var <- round(var)
		stopifnot(all(var > 0 & var <= ncol(data)))
		var <- names(data)[var]
	} else {
		stopifnot(all(var %in% names(data)))
	}
	
	out <- lapply(var, function(v) {
		if (is.factor(data[[v]])) {
			steps <- levels(data[[v]])
		} else {
			if (is.null(rng)) { 
				rng <- range(data[[v]]) 
			}
			increment <- (rng[2] - rng[1])/(nsteps-2)
			steps <- seq(rng[1]-increment, rng[2]+increment, increment)
		}
		res <- rep(NA, length(steps))
		for (i in 1:length(steps)) {
			d <- data
			# to handle factors (#16)
			d[d[[v]] != steps[i], v] <- steps[i]
			p <- predict(model, d, ...)
			res[i] <- mean(p)
		}
		x <- data.frame(steps, res)
		names(x) <- c(v, "p")
		x
	})
	names(out) <- var
	if (plot) {
		nrnc <- .pnrnc(nr, nc, length(var))
		old.par <- graphics::par(no.readonly = TRUE)
		on.exit(graphics::par(old.par))
		graphics::par(mfrow=nrnc)
		for (i in 1:length(out)) {
			plot(out[[i]], type="l", las=1)
		}
		invisible(out)
	} else {
		out
	}
}


partialResponse2 <- function(model, data, var1, var2, var2levels, rng=NULL, nsteps=25, ...) {
	if (is.factor(data[[var1]])) {
		steps <- levels(data[[var1]])
	} else {
		if (is.null(rng)) { 
			rng <- range(data[[var1]]) 
		}
		increment <- (rng[2] - rng[1])/(nsteps-2)
		steps <- seq(rng[1]-increment, rng[2]+increment, increment)
	}
	res <- rep(NA, length(steps))
	out <- data.frame(var1=steps)	
	for (v in var2levels) {
		data[[var2]] <- v
		for (i in 1:length(steps)) {
			# to handle factors (#16)
			data[data[[var1]] != steps[i], var1] <- steps[i]
			##data[[var1]] <- steps[i]
			p <- stats::predict(model, data, ...)
			res[i] <- mean(p)
		}
		out[[paste(var2, v, sep="_")]] <- res
	}
	out
}

.divider <- function(x, n, env=NULL, alpha=1, ...) {
	stopifnot(geomtype(x) == "polygons")
	n <- round(n)
	stopifnot(n > 0)
	if (n == 1) return(deepcopy(x))
	xcrs <- crs(x) 
	crs(x) <- "+proj=utm +zone=1"
	s <- terra::spatSample(x, max(n*4, 1000, log(n) * 100), "regular")
	xy <- terra::crds(s)
	if (!is.null(env)) {
		e <- extract(env, s, ID=FALSE)
		alpha <- rep_len(alpha, 2)
		xy[,1] <- xy[,1] * alpha[1]
		xy[,2] <- xy[,2] * alpha[2]
		xy <- na.omit(cbind(xy, e))
	} 
	k <- stats::kmeans(xy, centers = n, ...)
	ctrs <- k$centers[, 1:2]
	if (!is.null(env)) {
		ctrs[,1] <- ctrs[,1] / alpha[1]
		ctrs[,2] <- ctrs[,2] / alpha[2]
	}
	v <- terra::voronoi(vect(ctrs), bnd=x)
	v <- terra::crop(v, x)
	crs(v) <- xcrs
	v
}



.stripper <- function(x, f=c(1/3, 2/3), vertical=TRUE){

	if ((any(f <= 0)) || (any(f >= 1))) {
		stop("f values must be > 0 and < 1")
	}
	u <- unique(f)
	if (length(u) < length(f)) {
		stop("f values must be unique")	
	}
	ord <- order(f)
	if (!all(ord == 1:length(ord))) {
		stop("f values must be in ascending order")		
	}
	
	totalArea <- expanse(x)
	e <- ext(x)
	ex <- data.frame(t(as.vector(e + 1)))
	e <- data.frame(t(as.vector(e)))
	
	if (vertical) {
		edges <- sapply(f, function(fraction){
			target <- totalArea * fraction
			target_function <- function(xm){
				expanse(crop(x, ext(ex$xmin, xm, ex$ymin, ex$ymax))) - target
			}
			stats::uniroot(target_function, lower=e$xmin+0.0000001, upper=e$xmax)$root
		})
		bnds <- matrix(c(ex$xmin, rep(edges,rep(2,length(edges))), ex$xmax), ncol=2, byrow=TRUE)
		a <- apply(bnds, 1, function(edges){ 
				r <- ext(edges[1], edges[2], ex$ymin, ex$ymax)
				crop(x,r)
			})
	} else {
		edges <- sapply(f, function(fraction){
			target <- totalArea * fraction
			target_function <- function(ym){
				expanse(crop(x, ext(ex$xmin, ex$xmax, ex$ymin, ym))) - target
			}
			stats::uniroot(target_function, lower=e$ymin+0.0000001, upper=e$ymax)$root
		})
		bnds <- matrix(c(ex$ymin, rep(edges,rep(2,length(edges))), ex$ymax), ncol=2, byrow=TRUE)
		a <- apply(bnds, 1, function(edges){ 
				r <- ext(ex$xmin, ex$xmax, edges[1], edges[2])
				crop(x,r)
			})
	}
				
	vect(a)
}

# author: Jean-Pierre Rossi <jean-pierre.rossi@supagro.inra.fr>
# modifications by Robert Hijmans and Paulo van Breugel
# rewritten for predicts by RH

.messi <- function(p, v) {
	
	v <- sort(v)
	f <- 100 * findInterval(p, v) / length(v)
	minv <- v[1]
	maxv <- v[length(v)]
	res <- 2*f 
	f[is.na(f)] <- -99
	i <- f>50 & f<100
	res[i] <- 200-res[i]

	i <- f==0 
	res[i] <- 100*(p[i]-minv)/(maxv-minv)
	i <- f==100
	res[i] <- 100*(maxv-p[i])/(maxv-minv)
	res
}


.messix <- function(p,v) {
# a little bit different, no negative values.
	a <- stats::ecdf(v)(p)
	a[a>0.5] <- 1-a[a>0.5]
	200 * a
}



setMethod("mess", signature(x="SpatRaster"), 
	function(x, v, full=FALSE, filename="", ...) {

		if (inherits(v, "SpatVector")) {
			if (geomtype(p) != "points") {
				stop("SpatVector v must have points geometry")
			}
			v <- extract(v, x)
		}
		v <- stats::na.omit(v)
		if (nrow(v) < 2) {
			stop("insufficient number of reference points")
		}
		stopifnot(NCOL(v) == nlyr(x))

		out <- rast(x)
		nl <- nlyr(x)
		nms <- paste0(names(x), "_mess")
		readStart(x)
		on.exit(readStop(x))
		if (nl == 1) {
			names(out) <- "mess"
			b <- writeStart(out, filename, ...)
			for (i in 1:b$n) {		
				vv <- terra::readValues(x, b$row[i], b$nrows[i])
				p <- .messi(vv, v)
				terra::writeValues(out, p, b$row[i], b$nrows[i])
			}
		} else {
			if (full) {
				nlyr(out) <- nl+1
				names(out) <- c(nms, "mess")
				b <- writeStart(out, filename, ...)
				for (i in 1:b$n) {
					vv <- terra::readValues(x, b$row[i], b$nrows[i], mat=TRUE)
					vv <- sapply(1:ncol(v), function(i) .messi(vv[,i], v[,i]))
					suppressWarnings(m <- apply(vv, 1, min, na.rm=TRUE))
					m[!is.finite(m)] <- NA
					terra::writeValues(out, cbind(vv, m), b$row[i], b$nrows[i])
				}
			} else {			
				nlyr(out) <- 1
				names(out) <- "mess"
				b <- writeStart(out, filename, ...)
				for (i in 1:b$n) {
					vv <- terra::readValues(x, b$row[i], b$nrows[i], mat=TRUE)
					vv <- sapply(1:ncol(v), function(i) .messi(vv[,i], v[,i]))
					suppressWarnings(m <- apply(vv, 1, min, na.rm=TRUE))
					m[!is.finite(m)] <- NA
					terra::writeValues(out, m, b$row[i], b$nrows[i])
				}
			}
		}
		writeStop(out)
		out
	}	
)

setMethod("mess", signature(x="data.frame"), 
	function(x, v, full=FALSE) {
		if (ncol(x) == 1) {
			data.frame(mess=.messi(x, v))
		} else {
			x <- sapply(1:ncol(x), function(i) .messi(x[,i], v[,i]))
			rmess <- apply(x, 1, min, na.rm=TRUE)
			if (full) {
				out <- data.frame(x, rmess)
				nms <- paste0(names(x), "_mess")
				names(out) <- c(nms, "mess")
				out
			} else {
				data.frame(mess=rmess)
			}
		}	
	}
)

if (!isGeneric("hullModel")) {setGeneric("hullModel", function(p, ...)	standardGeneric("hullModel"))}
if (!isGeneric("geometry")) { setGeneric("geometry", function(x, ...) standardGeneric("geometry"))}

if (!isGeneric("MaxEnt")) { setGeneric("MaxEnt", function(x, p, ...) standardGeneric("MaxEnt"))}	
if (!isGeneric("mess")) { setGeneric("mess", function(x, ...) standardGeneric("mess")) }	

if (!isGeneric("plot")) { setGeneric("plot", function(x, y,...) standardGeneric("plot"))}
if (!isGeneric("predict")) { setGeneric("predict", function(object, ...) standardGeneric("predict"))}	

# Author: Robert J. Hijmans, r.hijmans@gmail.com
# Date: 2009-2021
# Version 0.1
# Licence GPL v3

setClass("MaxEnt_model",
	contains = "SDM",
	representation (
		lambdas  = "vector",
		results = "matrix",
		path = "character",
		html = "character",
		levels = "list"		
	),	
	prototype (	
		lambdas = as.vector(NA),
		results = as.matrix(NA),
		path = "",
		html = "",
		levels = list()
	),
)


setClass("MaxEnt_model_replicates",
	representation (
		models  = "list",
		results = "matrix",
		html = "character"
	),	
	prototype (	
		models = list(),
		results = as.matrix(NA),
		html = ""
	),
)


.getMeVersion <- function(...) {}

setMethod("MaxEnt", signature(x="missing", p="missing"), 
	function(x, p, silent=FALSE, ...) {

		if (is.null(getOption("predicts_rJavaLoaded"))) {
			# to avoid trouble on macs
			Sys.setenv(NOAWT=TRUE)
			if ( requireNamespace("rJava") ) {
				rJava::.jpackage("predicts")
				options(predicts_rJavaLoaded=TRUE)
			} else {
				if (!silent) {
					message("Cannot load rJava")			
				}
				return(FALSE)
			}
		}

		if (is.null(getOption("predicts_maxent"))) {
			mxe <- rJava::.jnew("meversion") 
			v <- try(rJava::.jcall(mxe, "S", "meversion"), silent=TRUE)
			if (inherits(v, "try-error")) {
				if (!silent) {
					message("MaxEnt_model is missing or incompatible with your version of Java")
				}
				return(FALSE)
			} else if (v == "3.3.3a") {
				if (!silent) {
					message("This is not a compatible version of Maxent")
				}
				return(FALSE)
			}
			options(predicts_maxent=v)
		} else {
			v = getOption("dismo_maxent")
		}
		if (!silent) {
			message(paste("This is MaxEnt version", v))
		}
		invisible(TRUE)
	}
)



.getMatrix <- function(x) {
	if (inherits(x, "SpatVector")) {
		x <- geom(x)[,c("x", "y"), drop=FALSE]
	} 
	if (inherits(x, "data.frame")) {
		x <- as.matrix(x)
	}
	if (!inherits(x, "matrix" )) {
		stop("data should be  a matrix, data.frame, or SpatVector")
	}
	if (dim(x)[2] != 2) {
		stop("presence or background coordinates data should be a matrix or data.frame with 2 columns" ) 	
	}
	colnames(x) <- c("x", "y")
	return(x)
} 


.maxentFailedMsg <- function(dirout) {
	logf <- file.path(dirout, "maxent.log")
	if (!file.exists(logf)) {
		return(paste0("MaxEnt failed (no log file at '", logf, "')"))
	}
	lines <- tryCatch(readLines(logf, warn=FALSE), error=function(e) character())
	errlines <- grep("^(Error|Exception)", lines, value=TRUE)
	if (length(errlines) > 0) {
		return(paste0("MaxEnt failed:\n  ", paste(errlines, collapse="\n  "),
			"\n(full log: '", logf, "')"))
	}
	if (length(lines) == 0) {
		return(paste0("MaxEnt failed (empty log at '", logf, "')"))
	}
	n <- min(20, length(lines))
	paste0("MaxEnt failed. Tail of '", logf, "':\n  ",
		paste(utils::tail(lines, n), collapse="\n  "))
}

.get_path <- function(path) {
	if (!is.null(path)) {
		path <- trimws(path)
		dir.create(path, recursive=TRUE, showWarnings=FALSE)
		if (!dir.exists(path)) {
			stop("cannot create output directory: ", path)
		}
	} else {
		path <- .meTmpDir()
		f <- paste(round(stats::runif(10)*10), collapse="")
		path <- paste(path, "/", f, sep="")
		dir.create(path, recursive=TRUE, showWarnings=FALSE)
		if (!dir.exists(path)) {
			stop("cannot create output directory: ", f)
		}
	}
	#file.remove(file.path(path, "maxent.html"))
	path
}

.biasBackground <- function(x, nbg, biasfile, path) {
	if (!inherits(biasfile, "SpatRaster")) {
		stop("'biasfile' must be a SpatRaster")
	}
	biasfile <- biasfile[[1]]
	compareGeom(biasfile, x[[1]], stopOnError=TRUE)
	bpts <- spatSample(biasfile, nbg, method="weights", na.rm=TRUE, as.points=TRUE, values=FALSE, warn=FALSE)
	utils::write.csv(crds(bpts), file.path(path, "background_locations.csv"), row.names=FALSE)
	av <- extract(x, bpts, ID=FALSE)
	stats::na.omit(av)
}


#factors=NULL, 
setMethod("MaxEnt", signature(x="SpatRaster", p="ANY"), 
	function(x, p, a=NULL, removeDuplicates=TRUE, nbg=10000, biasfile=NULL, args=NULL, path=NULL, ...) {

		dots <- list(...)
		if (!is.null(dots$args)) { #redundant with <data.frame> method check but nice to catch early
			bi <- grep("^biasfile=", trimws(dots$args), ignore.case=TRUE)
			if (length(bi) > 0) {
				stop("args='biasfile=..' cannot be used here. Either use the 'biasfile' argument directly\nor supply a bias-weighted background via 'a'.", call.=FALSE)
			}
		}
		path <- .get_path(path)

		p <- predicts:::.getMatrix(p)
		if (removeDuplicates) {
			cells <- unique(cellFromXY(x, p))
			pv <- extract(x, cells)
		} else {
			pv <- extract(x, p)
		}

		lpv <- nrow(pv)
		pv <- stats::na.omit(pv)
		nas <- lpv - nrow(pv)
		if (nas > 0) {
			if (nas >= 0.5 * lpv) {
				stop("more than half of the presence points have NA predictor values")
			} else {
				warning(nas, " (", round(100*nas/lpv,2), "%) of the presence points have NA predictor values")
			}
		} 
		
		if (!is.null(a) ) {
			if (!is.null(biasfile)) {
				stop("'biasfile' cannot be used as background points 'a' were supplied (draw 'a' with the bias grid as sampling weights?)") 
			}
			a <- .getMatrix(a)
			av <- extract(x, a)
			avr <- nrow(av)
			av <- stats::na.omit(av)
			nas <- length(as.vector(attr(av, "na.action")))
			if (nas > 0) {
				if (nas >= 0.5 * avr) {
					stop("more than half of the background points have NA predictor values")
				} else {
					warning(nas, " (", round(100*nas/avr, 2), "%) of the background points have NA predictor values")
				}
			}
		} else { 
		# (bias-weighted) random background
			if (is.null(nbg)) {
				nbg <- 10000 
			} else {
				if (nbg < 100) {
					stop("number of background points too low")
				} else if (nbg < 1000) {
					warning("number of background points is very low")
				}
			}
			if (is.null(biasfile)) {
				av <- spatSample(x, nbg, "random", na.rm=TRUE, warn=FALSE, as.points=TRUE)
				utils::write.csv(crds(av), file.path(path, "background_locations.csv"), row.names=FALSE)
				av <- values(av)
			} else {
				av <- .biasBackground(x, nbg, biasfile, path)
			}
			if (nrow(av) < 100) {
				stop("only got: ", nrow(av), " random background point values; is there a layer with many NA values?")
			}
			if (nrow(av) < 1000) {
				warning("only got: ", nrow(av), " random background point values; Small exent? Or is there a layer with many NA values?")
			}
		}
		
		# Signature = data.frame, missing

		v <- rbind(pv, av)
		
#		if (!is.null(factors)) {
#		  for (f in factors) {
#		    x[,f] <- factor(x[,f])
#		  }
#		}
		
		p <- c(rep(1, nrow(pv)), rep(0, nrow(av)))
		MaxEnt(v, p, path=path, args=args, ...)	
	}
)


.getreps <- function(args) {
	if (is.null(args)) { return(1) } 
	args <- trimws(args)
	i <- which(substr(args,1,10) == "replicates")
	if (! isTRUE(i > 0)) {
		return(1)
	} else {
		i <- args[i]
		i <- strsplit(i, "=")[[1]][[2]]
		return(as.integer(i))
	}
}



setMethod("MaxEnt", signature(x="data.frame", p="numeric"), 
	function(x, p, args=NULL, path=NULL, silent=FALSE, ...) {
	
		stopifnot(MaxEnt(silent=TRUE))

		x <- cbind(p, x)
		x <- stats::na.omit(x)

		bi <- grep("^biasfile=", trimws(args), ignore.case=TRUE)
		if (length(bi) > 0) {
			stop("'biasfile=' cannot be used here. Either use the 'biasfile' argument\nin the MaxEnt<SpatRaster> method or supply a bias-weighted background via 'a'.", call.=FALSE)
		}

		nodata <- grep("nodata=", args, value=TRUE)
		if (length(nodata) == 1) {
			nodata = as.numeric(strsplit(nodata, "=")[[1]][2])
			x[is.na(x)] <- nodata			
		} else {
			x[is.na(x)] <- -9999 
		}

		p <- x[,1]
		x <- x[, -1 ,drop=FALSE]

		me <- new("MaxEnt_model")

		me@presence <- x[p==1, ,drop=FALSE]
		me@absence <- x[p==0, ,drop=FALSE]

		factors <- names(x)[sapply(x, is.factor)]
		for (f in factors) {
			me@levels[[f]] <- levels(x[[f]])
			x[f] <- as.integer(x[[f]])
		}
		
		dirout <- .get_path(path)
		me@path <- dirout
		
		pv <- x[p==1, ,drop=FALSE]
		av <- x[p==0, ,drop=FALSE]
		#me@presence <- pv
		#me@absence <- av
		
		pv <- cbind(data.frame(species="species"), x=1:nrow(pv), y=1:nrow(pv), pv)
		av <- cbind(data.frame(species="background"), x=1:nrow(av), y=1:nrow(av), av)
		
		pfn <- paste(dirout, "/presence", sep="")
		afn <- paste(dirout, "/background", sep="")
		utils::write.csv(pv, file=pfn, row.names=FALSE)
		utils::write.csv(av, file=afn, row.names=FALSE)

		mxe <- rJava::.jnew("mebridge")
		
		names(args) = NULL
		replicates <- predicts:::.getreps(args) 
		args <- c("-z", args)

		# factors = NULL
		if (is.null(factors)) {
			str <- rJava::.jcall(mxe, "S", "fit", c("autorun", "-e", afn, "-o", dirout, "-s", pfn, args)) 
		} else {
			str <- rJava::.jcall(mxe, "S", "fit", c("autorun", "-e", afn, "-o", dirout, "-s", pfn, args), rJava::.jarray(factors))
		}
		if (!is.null(str)) {
			stop(paste0("args not understood:\n", str))
		}

	
		if (replicates > 1) {
		
			mer <- new("MaxEnt_model_replicates")
			d <- t(utils::read.csv(file.path(dirout, "maxentResults.csv")))
			d1 <- d[1,]
			d <- d[-1, ,drop=FALSE]
			dd <- matrix(as.numeric(d), ncol=ncol(d))
			rownames(dd) <- rownames(d)
			colnames(dd) <- d1
			mer@results <- dd
			f <- file.path(dirout, "species.html")
			html <- readLines(f)
			html[1] <- "<title>Maxent model</title>"
			html[2] <- "<CENTER><H1>Maxent model</H1></CENTER>"
			html[3] <- sub("model for species", "model result", html[3])
			newtext <- paste("using 'predicts' version ", utils::packageDescription("predicts")$Version, "& Maxent version")
			html[3] <- sub("using Maxent version", newtext, html[3])
			f <- file.path(dirout, "maxent.html")
			writeLines(html, f)	
			mer@html <- normalizePath(f)
						
			for (i in 0:(replicates-1)) {	
				mex <- me
				mex@lambdas <- unlist( readLines( file.path(dirout, paste0("species_", i, ".lambdas") ) ))
					
				f <- file.path(mex@path, paste0("species_", i, ".html"))
				html <- readLines(f)
				html[1] <- "<title>Maxent model</title>"
				html[2] <- "<CENTER><H1>Maxent model</H1></CENTER>"
				html[3] <- sub("model for species", "model result", html[3])
				newtext <- paste("using 'predicts' version ", utils::packageDescription("predicts")$Version, "& Maxent version")
				html[3] <- sub("using Maxent version", newtext, html[3])
				f <- paste(mex@path, "/maxent_", i, ".html", sep="")
				writeLines(html, f)
				mex@html <- normalizePath(f)
				mer@models[[i+1]] <- mex
				mer@models[[i+1]]@results <- dd[, 1+1, drop=FALSE]				
			}
			
			return(mer)
			
		} else {
			
			flambdas <- file.path(dirout, "species.lambdas")
			if (!file.exists(flambdas)) {
				stop(.maxentFailedMsg(dirout), call.=FALSE)
			}
			me@lambdas <- unlist( readLines( flambdas ) )
			d <- t(utils::read.csv(file.path(dirout, "maxentResults.csv") ))
			d <- d[-1, ,drop=FALSE]
			d[d=="na"] <- NA
			dd <- matrix(as.numeric(d))
			rownames(dd) <- rownames(d)
			me@results <- dd
			
			f <- file.path(me@path, "species.html")
			html <- readLines(f)
			html[1] <- "<title>Maxent model</title>"
			html[2] <- "<CENTER><H1>Maxent model</H1></CENTER>"
			html[3] <- sub("model for species", "model result", html[3])
			newtext <- paste("using 'predicts' version ", utils::packageDescription("predicts")$Version, "& Maxent version")
			html[3] <- sub("using Maxent version", newtext, html[3])
			f <- file.path(me@path, "maxent.html")
			writeLines(html, f)	
			me@html <- normalizePath(f)
		}
		
		me
	}
)


.meTmpDir <- function() {
	return( file.path(tempdir(), "maxent") )
}


.maxentRemoveTmpFiles <- function() {
	d <- .meTmpDir()
	if (file.exists(d)) {
		unlink(paste(d, "/*", sep=""), recursive = TRUE)
	}
}

setMethod("plot", signature(x="MaxEnt_model"), 
	function(x, ...) {
		r <- x@results
		rnames <- rownames(r)
		i <- grep(".contribution", rnames)
		r <- r[i, ]
		names(r) <- gsub(".contribution", "", names(r))
		r <- sort(r)
		dots <- list(...)
		if (is.null(dots$main)) dots$main="Variable contribution"
		if (is.null(dots$xlab)) dots$xlab="Percentage"
		dots$x <- r
		do.call(graphics::dotchart, dots)
		invisible(r)
	}
)



setMethod("predict", signature(object="MaxEnt_model_replicates"), 
	function(object, x, ext=NULL, filename="", args="", ...) {
		stopifnot(MaxEnt(silent=TRUE))

		n <- length(object@models)
		if (filename != "") {
			filename <- trimws(filename)
			fxt <- tools::file_ext(filename)
			filename <- tools::file_path_sans_ext(filename)
			fname <- paste(filename, "_", 1:n, fxt, sep="")
		} else {
			fname <- rep("", n)
		}
		lst <- list()
		for (i in 1:n) {
			lst[[i]] <- predict(object@models[[i]], x, ext=ext, filename=fname[i], args=args, ...)
		}
		return(rast(lst))
	}
)




.maxent_predict <- function(object, mxe, args, x) {
	lambdas <- paste(object@lambdas, collapse='\n')
	variables <- colnames(object@presence)
	x <- x[, variables, drop=FALSE]
	if (inherits(x, "data.frame")) {
		for (nm in names(object@levels)) {
			if (inherits(x[[nm]], "factor")) {
				if ((length(levels(x[[nm]])) == length(object@levels[[nm]])) && (all(levels(x[[nm]]) == object@levels[[nm]]))) {
					x[nm] <- as.integer(x[[nm]])
				} else {
					stop(paste0("levels of ", nm, " do not match the levels of the data used to fit model"))
				}
			} else {
				stop(paste("expecting a factor or character value for", nm))
			}	
		}
	}
	#else {
		#x[] <- as.numeric(x)
	#}
	
	out <- rep(NA, times=nrow(x))
	ok <- rowSums(is.na(x)) == 0
	if (sum(ok) > 0) {
		x <- as.matrix(x[ok, ,drop=FALSE])
		p <- rJava::.jcall(mxe, "[D", "predict", lambdas, rJava::.jarray(colnames(x)), rJava::.jarray(x, dispatch=TRUE), args)
		p[p < -9999] <- NA
		out[ok] <- p
	}
	out
}



setMethod("predict", signature(object="MaxEnt_model"), 
	function(object, x, ext=NULL, args="", filename="", ...) {

		stopifnot(MaxEnt(silent=TRUE))

		args <- c(args, "")
		lambdas <- paste(object@lambdas, collapse="\n")
		variables <- colnames(object@presence)
			
		mxe <- rJava::.jnew("mebridge") 		
		args <- c("-z", args)
		tst <- rJava::.jcall(mxe, "S", "testPredictArgs", lambdas, args) 
		if (!is.null(tst)) {
			stop("args not understood:\n", tst)
		}

		if (!inherits(x, "SpatRaster")) {
			if (! all(variables %in% colnames(x))) {
				stop("missing predictor variables in x")
			}
			me <- .maxent_predict(object, mxe, args, x)
			return(me)
		}

		filename <- trimws(filename)
			
		if (! all(variables  %in%  names(x) )) {
			stop("missing layers (or wrong names)")
		}
		if (nlyr(x) > length(variables)) {
			x <- x[[variables]]
		}
		if (!is.null(ext)) {
			x <- terra::crop(x, ext)
		}
		out <- terra::rast(x, nlyr=1)
		names(out)  <- "maxent"
		ncols <- terra::ncol(out)
		terra::readStart(x)
		on.exit(terra::readStop(x))
		b <- terra::writeStart(out, filename, ...)
		for (i in 1:b$n) {
			rowvals <- terra::readValues(x, b$row[i], b$nrows[i], 1, ncol(x), FALSE, TRUE)
			p <- .maxent_predict(object, mxe, args, rowvals)
			terra::writeValues(out, p, b$row[i], b$nrows[i])
		}
		terra::writeStop(out)
		return(out)
	}
)
		
		

setMethod ("show" , "MaxEnt_model", 
	function(object) {
		cat("class    :" , class(object), "\n")
		cat("variables:", colnames(object@presence), "\n")
		# cat("lambdas\n")
		# print(object@lambdas)
#		pp <- nrow(object@presence)
#		cat("\npresence points:", pp, "\n")
#		if (pp < 5) { 
#			print(object@presence)
#		} else {
#			print(object@presence[1:5,])
#			cat("  (... ...  ...)\n")
#			cat("\n")
#		}
#		pp <- nrow(object@absence)
#		cat("\nabsence points:", pp, "\n")
#		if (pp < 5) {
#			print(object@absence)
#		} else {
#			print(object@absence[1:5,])
#			cat("  (... ...  ...)\n")
#			cat("\n")
#		}
#		cat("\nmodel fit\n")
#		print(object@results)
#		cat("\n")

		if (file.exists(object@html)) {
			utils::browseURL( paste("file:///", object@html, sep="") )
		} else {
			cat("output html file no longer exists\n")
		}
	}
)	



setMethod ("show" , "MaxEnt_model_replicates", 
	function(object) {
		cat("class     :" , class(object), "\n")
		cat("replicates:", length(object@models), "\n")
		if (file.exists(object@html)) {
			utils::browseURL( paste("file:///", object@html, sep="") )
		} else {
			cat("model html no longer exists\n")
		}
	}
)	

		

setClass("hull_model",
	contains = "SDM",
	representation (
		type = "character",
		polygons="SpatVector"
	),	
	prototype (	
		type="",
		polygons = vect()
	),
	validity = function(object)	{
		return(TRUE)
	}
)


setMethod("geometry", "hull_model",
	function(x) {
		x@polygons
	}
)

setMethod("plot", signature(x="hull_model", y="missing"), 
	function(x, ...) {
		terra::plot(x@polygons, ...)
	}
)

setMethod("lines", signature(x="hull_model"), 
	function(x, ...) {
		terra::lines(x@polygons, ...)
	}
)


.k_convexHulls <- function(xy, k) {

	if (k > (nrow(xy) / 2)) {
		stop('too many clusters (there should be at least twice as many points)')
	}

	cl <- stats::kmeans(xy, k, 100)$cluster
	clusters <- unique(cl)
	if (any(table(cl) < 3)) {
		stop("too many clusters (cluster with less than three points found)")
	}
	h <- vector(mode="list", length=k)
	xy <- data.frame(xy)
	for (i in clusters) {
		pts <- vect(xy[cl==i, ], geom=colnames(xy))
		h[[i]] <- terra::hull(pts, "convex")
	}
	vect(h)
}

.makeHullModel <- function(xy, crs="", type="circle", n=1) {
	
	type <- tolower(type)
	type <- match.arg(type, c("circle", "rectangle", "convex"))
	n <- round(n)
	
	m <- new("hull_model")
	
	stopifnot(nrow(xy) > 1)
	if (!inherits(xy, "SpatVector")) {
		m@presence <- data.frame(xy)
		lonlat <- is.lonlat(as.character(crs))
		xy <- vect(m@presence, geom=colnames(xy), crs=crs)
	} else {
		if (geomtype(p) != "points") {
			stop("SpatVector v must have points geometry")
		}
		m@presence <- data.frame(crds(xy))
		lonlat <- is.lonlat(xy)
	}
	xy <- na.omit(xy)

	if (is.na(lonlat)) {
		if (is.lonlat(xy, perhaps=TRUE)) {
			lonlat <- TRUE
			crs(xy) <- "+proj=longlat"
		} else {
			lonlat <- FALSE
			crs(xy) <- "planar"
		}
	} 

	if (type == "convex") {
		if (n > 1) {
			xy <- .k_convexHulls(xy, n)
		} else {
			xy <- terra::hull(xy, "convex")
		}
		if (lonlat) {
			xy <- densify(xy, 10000)
		}
		m@polygons <- xy
	} else if (type == "rectangle") {
		if (n > 1) {
			xy <- .k_convexHulls(xy, n)
			h <- vector(mode="list", length=n)
			for (i in 1:n) {
				h[[i]] <- terra::hull(xy[i,], "rectangle")
			}
			xy <- vect(h)
		} else {
			xy <- hull(xy, "rectangle")
		}
		if (lonlat) {
			xy <- densify(xy, 10000)
		}
		m@polygons <- xy	
	} else if (type == "circle") {
		if (n > 1) {
			kxy <- .k_convexHulls(xy, n)
			h <- vector(mode="list", length=n)
			for (i in 1:n) {
				xy <- crds(kxy[i,])
				f <- function(p) { max(distance(rbind(p), xy, lonlat=lonlat)) }
				p <- stats::optim(colMeans(xy), f)
				v <- terra::vect(rbind(p$par), crs=crs)
				b <- buffer(v, width=p$value, quadsegs=45)
				values(b) <- data.frame(x=p$par[1], y=p$par[2], r=p$value)
				h[[i]] <- b
			}
			b <- vect(h)
		} else {
			xy <- terra::hull(xy, "convex")
			xy <- crds(xy)
			f <- function(p) { max(distance(rbind(p), xy, lonlat=lonlat)) }
			p <- stats::optim(colMeans(xy), f)
			v <- terra::vect(rbind(p$par), crs=crs)
			b <- buffer(v, width=p$value, quadsegs=45)
			values(b) <- data.frame(x=p$par[1], y=p$par[2], r=p$value)
		}
		m@polygons <- b
	}
	m
}



setMethod("hullModel", signature(p="data.frame"), 
	function(p, type="convex", crs=NA, n=1) {
		.makeHullModel(p, type=type, crs=crs, n=n)
	}
)

setMethod("hullModel", signature(p="matrix"), 
	function(p, type="convex", crs=NA, n=1) {
		.makeHullModel(data.frame(p), type=type, crs=crs, n=n)
	}
)

setMethod("hullModel", signature(p="SpatVector"), 
	function(p, type="convex", n=1) {
		.makeHullModel(p, type=type, crs=crs, n=n)
	}
)



setMethod("predict", signature(object="hull_model"), 
	function(object, x, ext=NULL, mask=FALSE, filename="",  ...) {
	
		nc <- nrow(object@polygons)
		if ( inherits(x, "SpatRaster"))  {
			if (! mask) {
				x <- rast(x)
			}
			if (! is.null(ext)) { 
				x <- crop(x, ext) 
			}
			
			xx <- rasterize(object@polygons, x, field=1, fun="sum")
			if (mask) {
				xx <- mask(xx, x, ...)
			}
			#if (nc > 1) {
			#	fun <- function(x){x / nc }
			#	xx <- app(xx, fun=fun, filename=filename, ...)
			#} else 
			if (filename != "") {
				xx <- writeRaster(xx, filename, ...)
			}
			return(xx)
		} else {
		
			if (!inherits(x, "SpatVector") )  {
				x <- data.frame(x)
				x <- vect(x, geom=colnames(x)[1:2])
			}
			as.integer(is.related(x, object@polygons, "coveredby"))
			# / nc
		}
	}
)

# Author: Robert J. Hijmans
# Date : December 2009
# Version 0.1
# Licence GPL v3


backgroundSample <- function(mask, n, p, ext=NULL, extf=1.1, excludep=TRUE, cellnumbers=FALSE, tryf=3, warn=2) {
	
	#mask <- mask[[1]]	
	tryf <- max(round(tryf[1]), 1)
	
	if (missing(p)) { 
		excludep <- FALSE
	} else {
		if (inherits(p, 'SpatVector')) {
			p <- geom(p)[, c("x", "y")]
		}
	}
	
	if (inherits(ext, "character")) {
		if (! (ext %in% 'points') ) { 
			stop("if ext is a character variable it should be 'points'") 
		} else if (missing(p)) { 
			warning("if p is missing, 'ext=points' is meaningless") 
			ext <- ext(mask)  
		} else {
			ext <- ext(min(p[,1]), max(p[,1]), min(p[,2]), max(p[,2]))
		}
	} 

	if (! is.null(ext)) {
		ext <- ext(ext)
		ext <- ext * extf
		ext <- intersect(ext, ext(mask))
		mask2 <- crop(rast(mask), ext)
	}  else {
		mask2 <- rast(mask)
	}
	
	if (n > ncell(mask2)) {
		n <- ncell(mask2)
		if (warn>0) { warning('changed n to ncell of the mask (extent)') }
	}
	
	nn <- n * tryf
	nn <- max(nn, 10)

	nn <- min(ncell(mask2), nn)
	cells <- as.vector(spatSample(mask2, nn, cells=TRUE))
	if (hasValues(mask)) {
		vals <- cbind(cells, terra::extract(mask, cells))
		cells <- stats::na.omit(vals)[,1]
	}
		
	if (excludep) {	
		pcells <- cellFromXY(mask, p)
		cells <- cells[ ! (cells %in% pcells) ] 	
	}

	if (length(cells) > n) { 
		
		cells <- sample(cells, n) 
		
	} else if (length(cells) < n) {
	
		frac <- length(cells) / n
		if (frac < 0.1) {
			stop("generated random points = ", frac," times requested number; Use a higher value for tryf" )
		}
		if (frac < 0.5  & warn==1) {
			warning("generated random points = ", frac," times requested number; Use a higher value for tryf" )
		} else if (warn > 1) {
			warning("generated random points = ", frac," times requested number")
		}
	}
	
	if (cellnumbers) {
		return(cells)
	} else {
		return(xyFromCell(mask, cells))
	}
}

# Author: Robert Hijmans
# November 2009
# License GPL3
#
# based on:
# MkBCvars.AML 
# Author Robert Hijmans
# January 2006  
# Museum of Vertebrate Zoology, UC Berkeley
#
# Version 2.3
#
# function to create19 BIOCLIM variables from 
# monthly T-min, T-max, and Precipitation data
#
# BIO1 = Annual Mean Temperature
# BIO2 = Mean Diurnal Range (Mean of monthly (max temp - min temp))
# BIO3 = Isothermality (P2/P7) (* 100)
# BIO4 = Temperature Seasonality (standard deviation *100)
# BIO5 = Max Temperature of Warmest Month
# BIO6 = Min Temperature of Coldest Month
# BIO7 = Temperature Annual Range (P5-P6)
# BIO8 = Mean Temperature of Wettest Quarter
# BIO9 = Mean Temperature of Driest Quarter
# BIO10 = Mean Temperature of Warmest Quarter
# BIO11 = Mean Temperature of Coldest Quarter
# BIO12 = Annual Precipitation
# BIO13 = Precipitation of Wettest Month
# BIO14 = Precipitation of Driest Month
# BIO15 = Precipitation Seasonality (Coefficient of Variation)
# BIO16 = Precipitation of Wettest Quarter
# BIO17 = Precipitation of Driest Quarter
# BIO18 = Precipitation of Warmest Quarter
# BIO19 = Precipitation of Coldest Quarter
# 
# These summary Bioclimatic variables are after:
#   Nix, 1986. A biogeographic analysis of Australian elapid snakes. In: R. Longmore (ed.).
#      Atlas of elapid snakes of Australia. Australian Flora and Fauna Series 7.
#      Australian Government Publishing Service, Canberra.
#
# and Expanded following the ANUCLIM manual
# 

.cv <- function(x) {
#  R function to compute the coefficient of variation (expressed as a percentage)
# if there is only a single value, stats::sd = NA. However, one could argue that cv =0. 
# and NA may break the code that receives it.
#The function returns NA if(aszero=FALSE)   else a value of 0 is returned.
	# abs to avoid very small (or zero) mean with e.g. -5:5
	m <- mean(abs(x), na.rm=TRUE)  
	if (!is.na(m) && (m == 0)) {
		return(0)
	} else {
		return(100 * stats::sd(x) / m)
	}
}


if (!isGeneric("bcvars")) {
	setGeneric("bcvars", function(prec, tmin, tmax, ...)
		standardGeneric("bcvars"))
}	


setMethod("bcvars", signature(prec="numeric", tmin="numeric", tmax="numeric"), 
	function(prec, tmin, tmax) {
		bcvars(t(as.matrix(prec)), t(as.matrix(tmin)), t(as.matrix(tmax)))
	}
)


setMethod("bcvars", signature(prec="SpatRaster", tmin="SpatRaster", tmax="SpatRaster"), 
	function(prec, tmin, tmax, filename="", ...) {

	if (nlyr(prec) != 12) stop("nlyr(prec) is not 12")
	if (nlyr(tmin) != 12) stop("nlyr(tmin) is not 12")
	if (nlyr(tmax) != 12) stop("nlyr(tmax) is not 12")
	
	
	x <- c(prec, tmin, tmax)
	readStart(x)
	on.exit(readStop(x))
	nc <- ncol(x)
	out <- rast(prec, nlyr=19)
	names(out) <- paste0("bio", 1:19)
	b <- writeStart(out, filename, ...)
	for (i in 1:b$n) {
		d <- readValues(x, b$row[i], b$nrows[i], 1, nc, TRUE, FALSE)
		p <- bcvars(d[,1:12], d[,13:24], d[,25:36])
		writeValues(out, p, b$row[i], b$nrows[i])
	}
	writeStop(out)
	return(out)
}
)




setMethod("bcvars", signature(prec="matrix", tmin="matrix", tmax="matrix"), 
	function(prec, tmin, tmax) {

		if (nrow(prec) != nrow(tmin) | nrow(tmin) != nrow(tmax) ) {
			stop("prec, tmin and tmax should have same length")
		}
		
		if (ncol(prec) != ncol(tmin) | ncol(tmin) != ncol(tmax) ) {
			stop("prec, tmin and tmax should have same number of variables (columns)")
		}
		
		# can"t have missing values in a row
		nas <- apply(prec, 1, function(x){ any(is.na(x)) } )
		nas <- nas | apply(tmin, 1, function(x){ any(is.na(x)) } )
		nas <- nas | apply(tmax, 1, function(x){ any(is.na(x)) } )
		p <- matrix(nrow=nrow(prec), ncol=19)
		colnames(p) = paste("bio", 1:19, sep="")
		if (all(nas)) { return(p) }
		
		prec[nas,] <- NA
		tmin[nas,] <- NA
		tmax[nas,] <- NA
		
		window <- function(x)  { 
			lng <- length(x)
			x <- c(x,  x[1:3])
			m <- matrix(ncol=3, nrow=lng)
			for (i in 1:3) { m[,i] <- x[i:(lng+i-1)] }
			apply(m, MARGIN=1, FUN=sum)
		}
		
		tavg <- (tmin + tmax) / 2
		
# P1. Annual Mean Temperature 
		p[,1] <- apply(tavg,1,mean)
# P2. Mean Diurnal Range(Mean(period max-min)) 
		p[,2] <- apply(tmax-tmin, 1, mean)
# P4. Temperature Seasonality (standard deviation) 
		p[,4] <- 100 * apply(tavg, 1, stats::sd)
# P5. Max Temperature of Warmest Period 
		p[,5] <- apply(tmax,1, max)
# P6. Min Temperature of Coldest Period 
		p[,6] <- apply(tmin, 1, min)
# P7. Temperature Annual Range (P5-P6) 
		p[,7] <- p[,5] - p[,6]
# P3. Isothermality (P2 / P7) 
		p[,3] <- 100 * p[,2] / p[,7]
# P12. Annual Precipitation 
		p[,12] <- apply(prec, 1, sum)
# P13. Precipitation of Wettest Period 
		p[,13] <-  apply(prec, 1, max)
# P14. Precipitation of Driest Period 
		p[,14] <-  apply(prec, 1, min)
# P15. Precipitation Seasonality(Coefficient of Variation) 
# the "1 +" is to avoid strange CVs for areas where mean rainfaill is < 1)
		p[,15] <- apply(prec+1, 1, .cv)
		
# precip by quarter (3 months)		
		wet <- t(apply(prec, 1, window))
# P16. Precipitation of Wettest Quarter 
		p[,16] <- apply(wet, 1, max)
# P17. Precipitation of Driest Quarter 
		p[,17] <- apply(wet, 1, min)
		tmp <- t(apply(tavg, 1, window)) / 3
		
		if (all(is.na(wet))) {
			p[,8] <- NA		
			p[,9] <- NA		
		} else {
# P8. Mean Temperature of Wettest Quarter 
			wetqrt <- cbind(1:nrow(p), as.integer(apply(wet, 1, which.max)))
			p[,8] <- tmp[wetqrt]
# P9. Mean Temperature of Driest Quarter 
			dryqrt <- cbind(1:nrow(p), as.integer(apply(wet, 1, which.min)))
			p[,9] <- tmp[dryqrt]
		}
# P10 Mean Temperature of Warmest Quarter 
		p[,10] <- apply(tmp, 1, max)

# P11 Mean Temperature of Coldest Quarter
		p[,11] <- apply(tmp, 1, min) 

		if (all(is.na(tmp))) {
			p[,18] <- NA		
			p[,19] <- NA
		} else {
# P18. Precipitation of Warmest Quarter 
			hot <- cbind(1:nrow(p), as.integer(apply(tmp, 1, which.max)))
			p[,18] <- wet[hot]
# P19. Precipitation of Coldest Quarter 
			cold <- cbind(1:nrow(p), as.integer(apply(tmp, 1, which.min)))
			p[,19] <- wet[cold]
		}
		
		return(p)	
	}
)

\name{folds}

\alias{folds}

\title{
Make folds for k-fold partitioning
}

\description{
k-fold partitioning of a data set for model testing purposes. Each record in a matrix (or similar data structure) is randomly assigned to a group. Group numbers are between 1 and \code{k}. The function assures that each fold has the same size (or as close to that as possible).
}


\usage{
folds(x, k=5, by)
}
 
\arguments{
  \item{x}{a vector, matrix, data.frame, or Spatial object}
  \item{k}{number of groups}
  \item{by}{Optional argument. A vector or factor with sub-groups (e.g. species). Its length should be the same as the number of records in x}
}

\value{
a vector with group assignments
}

\author{
Robert J. Hijmans
}

\examples{

library(disdat)
train <- disPo("NSW")
## a single species
srsp1 <- subset(train, spid=="nsw01")
folds(srsp1, k = 5)

## all species
k = folds(train, k=5, by=train$spid)

## each group has the same number of records 
##(except for adjustments if the number of records 
## divided by k is not an integer) 

table(k[train$spid=="nsw01"])
}

\keyword{spatial}

\name{MaxEnt}

\alias{MaxEnt_model-class}
\alias{MaxEnt_model_replicates-class}

\alias{MaxEnt}

\alias{MaxEnt,missing,missing-method}
\alias{MaxEnt,SpatRaster,ANY-method}
\alias{MaxEnt,data.frame,numeric-method}

\alias{MaxEnt_model-class}
\alias{MaxEnt_model_replicates-class}

\title{MaxEnt species distribution model}

\description{
Build a "maxent" (Maximum Entropy) species distribution model. The function uses environmental data for locations of known presence and for a large number of 'background' locations. Environmental data can be extracted from raster files. The result is a model object that can be used to predict the suitability of other locations, for example, to predict the entire range that is suitable for a species. 

Background points are sampled randomly from the cells that are not \code{NA} in the first predictor variable, unless background points are specified with argument \code{a}. 

This function uses the MaxEnt species distribution model software by Phillips, Dudik and Schapire available \href{https://biodiversityinformatics.amnh.org/open_source/maxent/}{here}.
}

\usage{
\S4method{MaxEnt}{SpatRaster,ANY}(x, p, a=NULL, removeDuplicates=TRUE, nbg=10000, 
		biasfile=NULL, args=NULL, path=NULL, ...)

\S4method{MaxEnt}{data.frame,numeric}(x, p, args=NULL, path, silent=FALSE, ...)

\S4method{MaxEnt}{missing,missing}(x, p, silent=FALSE, ...)
}

\arguments{
\item{x}{Predictors. Either a SpatRaster to extract values from for the locations in \code{y}; or a data.frame, in which case each column should be a predictor variable and each row a presence or background record. Either can include categorical variables (see \code{\link{as.factor}})}

\item{p}{If \code{x} is a SpatRaster: occurence data. This can be a data.frame, matrix, or SpatVector. If \code{p} is a data.frame or matrix it represents a set of point locations; and it must have two columns with the first being the x-coordinate (longitude) and the second the y-coordinate (latitude). 

If \code{x} is a data.frame, \code{p} should be a vector with a length equal to \code{nrow(x)} and contain 0 (background) and 1 (presence) values, to indicate which records (rows) in data.frame \code{x} are presence records, and which are background records}

\item{a}{Background points. Only used if \code{p} is not a vector and not missing}

\item{nbg}{Number of background points to use. These are sampled randomly from the cells that are not \code{NA} in the first predictor variable. Ignored if background points are specified with argument \code{a}} 

\item{biasfile}{Optional \code{SpatRaster} giving sampling weights for the background data. Only used if \code{x} is a SpatRaster and \code{a} is \code{NULL} to draw background points with probability proportional to the (non-negative) cell values. This is equivalent to MaxEnt's own \code{biasfile=} option, which is not supported here}

\item{args}{character. Additional argument that can be passed to MaxEnt. See the MaxEnt help for more information. The R MaxEnt function only uses the arguments relevant to model fitting. There is no point in using args='outputformat=raw' when *fitting* the model; but you can use arguments relevant for *prediction* when using the predict function. Some other arguments do not apply at all to the R implementation. An example is 'outputfiletype', because the 'predict' function has its own 'filename' argument for that. Note that \code{biasfile=...} in \code{args} is not supported; use the \code{biasfile} argument instead}

\item{removeDuplicates}{Boolean. If \code{TRUE}, duplicate presence points (that fall in the same grid cell) are removed}

\item{path}{character. Optional argument to set where you want the MaxEnt output files to be stored. This allows you to permanently keep these files. If not supplied the MaxEnt files will be stored in a temporary file. These are the files that are shown in a browser when typing the model name or when you use "show(model)"}

\item{silent}{Boolean. If \code{TRUE} a message is printed}

\item{...}{Additional arguments}
}



\value{
An object of class 'MaxEnt_model'. Or a 'MaxEnt_model_replicates' object if you use 'replicates=' as part of the \code{args} argument. 

If the function is run without any arguments a boolean value is returned (\code{TRUE} if MaxEnt.jar was found).
}

\seealso{
\code{\link[predicts]{predict}}
}

\author{Steven Phillips and Robert J. Hijmans}

\references{

Steven J. Phillips, Miroslav Dudik, Robert E. Schapire, 2004.  A maximum entropy approach to species distribution modeling. Proceedings of the Twenty-First International Conference on Machine Learning. p. 655-662.

Steven J. Phillips, Robert P. Anderson, Robert E. Schapire, 2006. Maximum entropy modeling of species geographic distributions. Ecological Modelling 190:231-259. 

Jane Elith, Steven J. Phillips, Trevor Hastie, Miroslav Dudik, Yung En Chee, Colin J. Yates, 2011. A statistical explanation of MaxEnt for ecologists. Diversity and Distributions 17:43-57. \doi{10.1111/j.1472-4642.2010.00725.x}
}

\examples{

# test the MaxEnt version 
MaxEnt()

\donttest{
# get predictor variables
ff <- list.files("tif$", path=system.file("ex", package="predicts"), full.names=TRUE)
preds <- rast(ff)
plot(preds)

# file with presence points
occurence <- system.file("/ex/bradypus.csv", package="predicts")
occ <- read.csv(occurence)[,-1]

# witholding a 20% sample for testing 
fold <- folds(occ, k=5)
occtest <- occ[fold == 1, ]
occtrain <- occ[fold != 1, ]

# fit model
me <- MaxEnt(preds, occtrain)

# see the MaxEnt results in a browser:
me

# use "args"
me2 <- MaxEnt(preds, occtrain, args=c("-J", "-P"))

# plot showing importance of each variable
plot(me)

# predict to entire dataset
r <- predict(me, preds) 

# with some options:
r <- predict(me, preds, args=c("outputformat=raw"))

plot(r)
points(occ)

#testing
# background sample
bg <- backgroundSample(preds, 1000)

#simplest way to use 'evaluate'
e1 <- pa_evaluate(me, p=occtest, a=bg, x=preds)

# alternative 1
# extract values
pvtest <- data.frame(extract(preds, occtest))
avtest <- data.frame(extract(preds, bg))

e2 <- pa_evaluate(me, p=pvtest, a=avtest)

# alternative 2 
# predict to testing points 
testp <- predict(me, pvtest) 
head(testp)
testa <- predict(me, avtest) 

e3 <- pa_evaluate(p=testp, a=testa)
e3
threshold(e3)

plot(e3, 'ROC')
}
}


\keyword{spatial}

\name{varImportance}

\alias{varImportance}

\title{
Get variable importance
}

\description{
Get variable importance. The importance is expressed as the deterioration of the evaluation statistic. The statistic is computed \code{n} times for model predictions after randomizing a predictor variable and subtracting the statistic for the non-randomized data. The larger the difference, the more important the variable is. 
}


\usage{
varImportance(model, y, x, n=10, stat, value="relative", ...)
}
 
\arguments{
  \item{model}{a model object}
  \item{y}{the response variable used to fit the \code{model}. If missing, it is attempted to extract it from \code{model}. If that fails, it is computed from \code{x}. In the latter case the model would be assumed to have no error}
  \item{x}{data.frame with the predictor variables used to fit the \code{model}. If missing, it is attemted to extract it from \code{model}}
  \item{n}{positive integer. Number of simulations}
  \item{stat}{character. For models with a continuous response variable this can be one of "RMSE" (the default), "AUC", or "cor". See \code{\link{RMSE}} or \code{\link{pa_evaluate}}. For models with a categorical response variable this can be one of "overall" (overall accuracy, the default) or "kappa", see \code{\link{cm_evaluate}}}
  \item{value}{character specifying how to express the output. One of , "relative" (), "difference" (), "absolute" (no adjustments)}
  \item{...}{model specific additional arguments passed to \code{predict}}
}

\value{
named numeric vector
}

\examples{

set.seed(1)
d <- data.frame(y=1:10, x1=runif(10), x2=runif(10))
m <- lm(y~., data=d)

varImportance(m, d[,1], d[,2:3])
}

\name{cm_evaluate}

\alias{cm_evaluate}

\title{Model evaluation with a confusion matrix}

\description{
Get model evaluation statistics from a confusion matrix. This is useful when predicting (multiple) classes.
}

\usage{
cm_evaluate(cmat, stat="overall")
}

\arguments{
  \item{cmat}{confusion matrix. Normally created with table (see examples)}
  \item{stat}{character. Either "overall" (overall accuracy), "kappa", "class" for user and producer accuracy}
}

\seealso{\code{\link{pa_evaluate}}}

\value{
numeric
}


\examples{  
classes <- c("forest", "water", "urban", "agriculture")
set.seed(1)
observed <- sample(classes, 100, replace=TRUE)
predicted <- observed
i <- seq(1,100,2)
predicted[i] <- sample(classes, length(i), replace=TRUE)
conmat <- table(observed, predicted)
conmat

cm_evaluate(conmat, "kappa")
cm_evaluate(conmat, "class")
}

\name{partialResponse}

\alias{partialResponse}
\alias{partialResponse2}

\title{
Get partial response data
}

\description{
Get partial response data.
}


\usage{
partialResponse(model, data, var=NULL, rng=NULL, nsteps=25, plot=TRUE, nr, nc, ...)
partialResponse2(model, data, var1, var2, var2levels, rng=NULL, nsteps=25, ...)
}
 
\arguments{
  \item{model}{a model object}
  \item{data}{data.frame with data for all model variables}
  \item{var}{character or positive integer to identify the variable(s) of interest in \code{data}. If this is \code{NULL}, the partial response is computed for all variables}
  \item{var1}{character or positive integer to identify the variable of interest in \code{data}}
  \item{var2}{character. A second variable of interest}
  \item{var2levels}{character. The levels of the second variable to consider}
  \item{rng}{optional vector of two numbers to set the range or the variable}
  \item{nsteps}{positive integer. Number of steps to consider for the variable}
  \item{plot}{logical. If \code{TRUE}, the responses are plotted}
  \item{nc}{positive integer. Optional. The number of columns to divide the plotting device in (when plotting multiple variables)}
  \item{nr}{positive integer. Optional. The number of rows to divide the plotting device in (when plotting multiple variables)}
  \item{...}{model specific additional arguments passed to \code{predict}}
}

\value{
list (invisible if \code{plot=TRUE})
}

\examples{
fsp <- system.file("/ex/bradypus.csv", package="predicts")
occ <- read.csv(fsp)[,-1]
f <- system.file("ex/bio.tif", package="predicts")
preds <- rast(f)[[c(1,7,9)]]
v <- extract(preds, occ, ID=FALSE)

bc <- envelope(v)

pr <- partialResponse(bc, data=v, var=c("bio1", "bio12"), nsteps=30)
str(pr)
}

\name{plot}

\docType{methods}

\alias{plot,envelope_model,missing-method}
\alias{plot,MaxEnt_model,ANY-method}

\title{
Plot predictor values 
}

\description{
Plot predictor values for occurrence (presence and absence) data in a model object.
}

\usage{
\S4method{plot}{envelope_model,missing}(x, a = 1, b = 2, p = 0.9, ocol="gray", icol="red", bcol="blue", cex=c(0.6, 0.6), ...)

\S4method{plot}{MaxEnt_model,ANY}(x, y, ...)
}

\arguments{
\item{x}{model object}
\item{a}{name or position of the variable to plot in the x axis}
\item{b}{name or position of the variable to plot in the y axis}
\item{p}{percentile for coloring the points in the plot and delimiting the envelope rectangle}
\item{ocol}{color of the points outside the envelope} 
\item{icol}{color of the points inside the envelope}
\item{bcol}{color of the envelope border}
\item{cex}{size of the points outside and inside the envelope}
\item{y}{not used}
\item{...}{additional arguments. Not used}
}


\keyword{spatial}

\name{RMSE}

\alias{RMSE}
\alias{RMSE_null}

\title{
Root Mean Square Error
}

\description{
Compute the Root Mean Square Error (RMSE)
}


\usage{
RMSE(obs, prd, na.rm=FALSE)

RMSE_null(obs, prd, na.rm=FALSE)
}
 
\arguments{
  \item{obs}{observed values}
  \item{prd}{predicted values}
  \item{na.rm}{logical. If \code{TRUE}, \code{NA}s are removed}
}

\value{
numeric
}

\name{predicts-package}

\alias{predicts-package}
\alias{predicts}

\docType{package}

\title{
Spatial prediction
}

\description{
This package implements functions for spatial predictions methods, especially spatial (species) distribution models, including an R link to the 'maxent' model.
}

\author{
Robert J. Hijmans
}

\keyword{ package }
\keyword{ spatial }

\name{predict}

\docType{methods}

\alias{predict}
\alias{predict,envelope_model-method}
\alias{predict,hull_model-method}
\alias{predict,MaxEnt_model-method}
\alias{predict,MaxEnt_model_replicates-method}


\title{Spatial model predictions}

\description{
Make predictions with models defined in the \code{predicts} package
}


\usage{
\S4method{predict}{MaxEnt_model}(object, x, ext=NULL, args="", filename="", ...)

\S4method{predict}{envelope_model}(object, x, tails=NULL, ext=NULL, filename="", ...)

\S4method{predict}{hull_model}(object, x, ext=NULL, mask=FALSE, filename="", ...)
}

\arguments{
  \item{object}{model defined in this package (e.g. "envelope_model" and "maxent_model")}
  \item{x}{data to predict to. Either a data.frame or a SpatRaster}
  \item{tails}{character. You can use this to ignore the left or right tail of the percentile distribution for a variable. If supplied, tails should be a character vector with a length equal to the number of variables used in the model. Valid values are "both" (the default), "low" and "high". For example, if you have a variable x with an observed distribution between 10 and 20 and you are predicting the bioclim value for a value of 25, the default result would be zero (outside of all observed values); but if you use tail='low', the high (right) tail is ignored and the value returned will be 1. }
  \item{args}{Pass *prediction* arguments (options) to the maxent software. See \code{\link[predicts]{maxent}}}
  \item{ext}{\code{NULL} or a \code{\link[terra]{SpatExtent}} to limit the prediction to a sub-region of \code{x}}
  \item{mask}{logical. If \code{TRUE} areas that are \code{NA} in \code{x} are set to \code{NA} in the output}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link[terra]{writeRaster}}} 
}


\value{
SpatRaster or vector (if \code{x} is a data.frame). 
}

\seealso{
\code{\link[terra]{predict}} function in the "terra" package for spatial predictions with glm, randomForest, etc.
}


\keyword{methods}
\keyword{spatial}

\name{hull_model}

\alias{hull_model-class}

\alias{hullModel}
\alias{hullModel,SpatVector-method}
\alias{hullModel,matrix-method}
\alias{hullModel,data.frame-method}

\alias{geometry}
\alias{geometry,hull_model-method}

\alias{plot,hull_model,missing-method}


\title{hull model}


\description{
The hull model predicts that a species is present at sites inside the a hull that contains the training points, and is absent outside that circle.

The hull can be "convex", "circle", or "rectangle"
}


\usage{
\S4method{hullModel}{SpatVector}(p, type="convex", n=1)

\S4method{hullModel}{data.frame}(p, type="convex", crs="", n=1)

\S4method{hullModel}{matrix}(p, type="convex", crs="", n=1)
}

\arguments{
  \item{p}{point locations (presence). Two column matrix, data.frame or SpatVector}
  \item{type}{character. The type of hull. One of "convex", "circle", or "rectangle"}
  \item{crs}{character. The coordinate reference system}
  \item{n}{positive integer. The number of hulls to make}
}


\value{
hull_model
}


\examples{
r <- rast(system.file("ex/logo.tif", package="terra"))   
#presence data
pts <- matrix(c(17, 42, 85, 70, 19, 53, 26, 84, 84, 46, 48, 85, 4,
    95, 48, 54, 66, 74, 50, 48, 28, 73, 38, 56, 43, 29, 63, 22, 46, 45,
    7, 60, 46, 34, 14, 51, 70, 31, 39, 26), ncol=2)
train <- pts[1:12, ]
test <- pts[13:20, ]
				 
ch <- hullModel(train, crs="+proj=longlat")
predict(ch, test)

plot(r)
plot(ch, border="red", lwd=2, add=TRUE)
points(train, col="red", pch=20, cex=2)
points(test, col="black", pch=20, cex=2)

pr <- predict(ch, r)
plot(pr)
points(test, col="black", pch=20, cex=2)
points(train, col="red", pch=20, cex=2)

# to get the polygons:
p <- geometry(ch)
p
}

\keyword{spatial}

\name{backgroundSample}
\alias{backgroundSample}

\title{
Random points
}

\description{
Generate random points that can be used to extract background values ("random-absence"). The points are sampled (without replacement) from the cells that are not '\code{NA}' in raster '\code{mask}'. 

If the coordinate reference system (of \code{mask}) is longitude/latitude, sampling is weighted by the size of the cells. That is, because cells close to the equator are larger than cells closer to the poles, equatorial cells have a higher probability of being selected.
}

\usage{
backgroundSample(mask, n, p, ext=NULL, extf=1.1, excludep=TRUE, 
             cellnumbers=FALSE, tryf=3, warn=2)
}
 
\arguments{
  \item{mask}{SpatRaster. If the object has cell values, cells with \code{NA} are excluded (of the first layer of the object if there are multiple layers)}
  \item{n}{integer. Number of points}
  \item{p}{Presence points (if provided, random points won't be in the same cells (as defined by mask)}
  \item{ext}{SpatExtent. Can be used to restrict sampling to a spatial extent}
  \item{extf}{numeric. Multiplyer to adjust the size of extent 'ext'. The default increases of 1.1 increases the extent a little (5\% at each side of the extent)}
  \item{excludep}{logical. If \code{TRUE}, presence points are exluded from background}
  \item{cellnumbers}{logical. If \code{TRUE}, cell numbers for \code{mask} are returned rather than coordinates }
  \item{tryf}{numeric > 1. Multiplyer used for initial sample size from which the requested sample size is extracted after removing NA points (outside of mask) }
  \item{warn}{integer. 2 or higher gives most warnings. 0 or lower gives no warnings if sample size \code{n} is not reached }
}

\value{
matrix with coordinates, or, if \code{cellnumbers=TRUE}, a vector with cell numbers.
}


\keyword{spatial}

\name{mess}

\alias{mess}
\alias{mess,SpatRaster-method}
\alias{mess,data.frame-method}

\title{Multivariate environmental similarity surfaces (MESS)}

\description{Compute multivariate environmental similarity surfaces (MESS), as described by Elith et al., 2010}

\usage{
\S4method{mess}{SpatRaster}(x, v, full=FALSE, filename="", ...)

\S4method{mess}{data.frame}(x, v, full=FALSE)
}

\arguments{
  \item{x}{SpatRaster or data.frame}
  \item{v}{matrix or data.frame containing the reference values; each column should correspond to one layer of the SpatRaster object. If \code{x} is a SpatRaster, it can also be a SpatVector with reference locations (points)}
  \item{full}{logical. If \code{FALSE} a SpatRaster with the MESS values is returned. If \code{TRUE}, a SpatRaster is returned with \code{n} layers corresponding to the layers of the input SpatRaster and an additional layer with the MESS values}
  \item{filename}{character. Output filename (optional)}
  \item{...}{additional arguments as for \code{\link[terra]{writeRaster}}}
}

\details{
\code{v} can be obtained for a set of points using \code{\link[terra]{extract}} .
}

\value{
SpatRaster (or data.frame) with layers (columns) corresponding to the input layers and an additional layer with the mess values (if \code{full=TRUE} and \code{nlyr(x) > 1}) or a SpatRaster (data.frame) with the MESS values (if \code{full=FALSE}).
}

\references{
Elith J., M. Kearney M., and S. Phillips, 2010. The art of modelling range-shifting species. Methods in Ecology and Evolution 1:330-342. \doi{10.1111/j.2041-210X.2010.00036.x}
}

\author{
Jean-Pierre Rossi, Robert Hijmans, Paulo van Breugel
}


\examples{

set.seed(9)
r <- rast(ncol=10, nrow=10)
r1 <- setValues(r, (1:ncell(r))/10 + rnorm(ncell(r)))
r2 <- setValues(r, (1:ncell(r))/10 + rnorm(ncell(r)))
r3 <- setValues(r, (1:ncell(r))/10 + rnorm(ncell(r)))
s <- c(r1,r2,r3)
names(s) <- c('a', 'b', 'c')
xy <- cbind(rep(c(10,30,50), 3), rep(c(10,30,50), each=3))
refpt <- extract(s, xy)

ms <- mess(s, refpt, full=TRUE)
plot(ms)

\dontrun{
filename <- paste0(system.file(package="predicts"), "/ex/bradypus.csv")
bradypus <- read.table(filename, header=TRUE, sep=',')
bradypus <- bradypus[,2:3]

predfile <- paste0(system.file(package="predicts"), "/ex/bio.tif")
predictors <- rast(predfile)
reference_points <- extract(predictors, bradypus, ID=FALSE)
mss <- mess(x=predictors, v=reference_points, full=TRUE)

breaks <- c(-500, -50, -25, -5, 0, 5, 25, 50, 100)
fcol <- colorRampPalette(c("blue", "beige", "red"))
plot(mss[[10]], breaks=breaks, col=fcol(9), plg=list(x="bottomleft"))
}

}

\name{envelope}

\alias{envelope}
\alias{envelope,SpatRaster-method}
\alias{envelope,matrix-method}
\alias{envelope,data.frame-method}

\alias{envelope_model-class}


\title{Fit a (climate) envelope model and make predictions}


\description{
The envelope algorithm has been extensively used for species distribution modeling under the name "bioclim model". This is the classic 'climate-envelope-model' that started what was later called species distribution modeling and ecological niche modeling. Although it generally does not perform as good as some other methods (Elith et al. 2006) and is unsuited for predicting climate change effects (Hijmans and Graham, 2006). It may be useful in certain cases, among other reasons because the algorithm is easy to understand and thus useful in teaching species distribution modeling. 

The algorithm computes the similarity of a location by comparing the values of environmental variables at any location to a percentile distribution of the values at known locations of occurrence ('training sites'). The closer to the 50th percentile (the median), the more suitable the location is. The tails of the distribution are not distinguished, that is, 10 percentile is treated as equivalent to 90 percentile. 

In this R implementation, percentile scores are between 0 and 1, but predicted values larger than 0.5 are subtracted from 1. Then, the minimum percentile score across all the environmental variables is computed (i.e. this is like Liebig's law of the minimum, except that high values can also be limiting factors). The final value is subtracted from 1 and multiplied with 2 so that the results are between 0 and 1. The reason for this transformation is that the results become more like that of other distribution modeling methods and are thus easier to interpret. The value 1 will rarely be observed as it would require a location that has the median value of the training data for all the variables considered. The value 0 is very common as it is assigned to all cells with a value of an environmental variable that is outside the percentile distribution (the range of the training data) for at least one of the variables. 

When using the \link[predicts]{predict} function you can choose to ignore one of the tails of the distribution (for example, to make low rainfall a limiting factor, but not high rainfall).
}


\usage{
envelope(x, ...)
}
 

\arguments{
  \item{x}{matrix or data.frame where each column is an environmental variable and each row an occurrence. Alternatively, a SpatRaster where each layer is an environmental variable, in which case you must also provide argument 'p': a SpatVector of the occurrence points, or a data.frame of their spatial coordinates. Only grid cells that overlap with occurrences are used.}
  \item{...}{ Additional arguments }
}


\value{
An object of class 'envelope_model'
}


\references{
Nix, H.A., 1986. A biogeographic analysis of Australian elapid snakes. In: Atlas of Elapid Snakes of Australia. (Ed.) R. Longmore, pp. 4-15. Australian Flora and Fauna Series Number 7. Australian Government Publishing Service: Canberra.

Booth, T.H., H.A. Nix, J.R. Busby and M.F. Hutchinson, 2014. BIOCLIM: the first species distribution modelling package, its early applications and relevance to most current MAXENT studies. Diversity and Distributions 20: 1-9

Elith, J., C.H. Graham, R.P. Anderson, M. Dudik, S. Ferrier, A. Guisan, R.J. Hijmans, F. Huettmann, J. Leathwick, A. Lehmann, J. Li, L.G. Lohmann, B. Loiselle, G. Manion, C. Moritz, M. Nakamura, Y. Nakazawa, J. McC. Overton, A.T. Peterson, S. Phillips, K. Richardson, R. Scachetti-Pereira, R. Schapire, J. Soberon, S. Williams, M. Wisz and N. Zimmerman, 2006. Novel methods improve prediction of species' distributions from occurrence data. Ecography 29: 129-151. \doi{10.1111/j.2006.0906-7590.04596.x}

Hijmans R.J., and C.H. Graham, 2006. Testing the ability of climate envelope models to predict the effect of climate change on species distributions. Global change biology 12: 2272-2281. \doi{10.1111/j.1365-2486.2006.01256.x}
}



\author{
Robert J. Hijmans
}

\seealso{
\code{\link[predicts]{predict}, \link[predicts]{maxent}}
}


\examples{
# file with presence points
fsp <- system.file("/ex/bradypus.csv", package="predicts")
occ <- read.csv(fsp)[,-1]

#predictors
f <- system.file("ex/bio.tif", package="predicts")
preds <- rast(f)[[c(1,7,9)]]

v <- extract(preds, occ)
bc <- envelope(v[,-1])

d <- preds[18324:18374]
predict(bc, d)

p1 <- predict(bc, preds)
p2 <- predict(bc, preds, tails=c("both", "low", "high"))

}

\keyword{spatial}

\name{pwd_sample}

\alias{pwd_sample}

\title{Pair-wise distance sampling}

\description{
Select pairs of points from two sets (without replacement) that have a similar distance to their nearest point in another set of points. 

For each point in "\code{fixed}", a point is selected from "\code{sample}" that has a similar distance (as defined by \code{threshold}) to its nearest point in "\code{reference}" (note that these are likely to be different points in \code{reference}). The select point is either the nearest point \code{nearest=TRUE}, or a randomly select point \code{nearest=FALSE} that is within the threshold distance. If no point within the threshold distance is found in \code{sample}, the point in \code{fixed} is dropped.

Hijmans (2012) proposed this sampling approach to remove 'spatial sorting bias' from evaluation data used in cross-validation of presence-only species distribution models. In that context, \code{fixed} are the testing-presence points, \code{sample} the testing-absence (or testing-background) points, and \code{reference} the training-presence points.
}

\usage{
pwd_sample(fixed, sample, reference, tr=0.33, nearest=TRUE, n=1, lonlat=TRUE, warn=TRUE) 
}
 
\arguments{
  \item{fixed}{two column matrix (x, y) or (longitude/latitude) or SpatialPoints object, for point locations for which a pair should be found in \code{sample} }
  \item{sample}{as above for point locations from which to sample to make a pair with a point from \code{fixed}}
  \item{reference}{as above for reference point locations to which distances are computed}
  \item{n}{How many pairs do you want for each point in \code{fixed}}
  \item{tr}{Numeric, normally below 1. The threshold distance for a pair of points (one of \code{fixed} and one of \code{sample}) to their respective nearest points in \code{reference} to be considered a valid pair. The absolute difference in distance between the candidate point pairs in \code{fixed} and \code{reference} (dfr) and the distance between candidate point pairs in \code{sample} and \code{reference} (dsr) must be smaller than \code{tr} * dfr. I.e. if the dfr = 100 km, and tr = 0.1, dsr must be between >90 and <110 km to be considered a valid pair.}
  \item{nearest}{Logical. If \code{TRUE}, the pair with the smallest difference in distance to their nearest \code{reference} point is selected. If \code{FALSE}, a random point from the valid pairs (with a difference in distance below the threshold defined by \code{tr}) is selected (generally leading to higher SSB}
  \item{lonlat}{ Logical. Use \code{TRUE} if the coordinates are spherical (in degrees), and use \code{FALSE} if they are planar }
  \item{warn}{ Logical. If \code{TRUE} a warning is given if \code{nrow(fixed) < nrow(sample)} }
}

\value{
A matrix of nrow(fixed) and ncol(n), that indicates, for each point (row) in \code{fixed} which point(s) in \code{sample} it is paired to; or \code{NA} if no suitable pair was available.
}

\references{
Hijmans, R.J., 2012. Cross-validation of species distribution models: removing spatial sorting bias and calibration with a null-model. Ecology 93: 679-688
}

\examples{
ref <- matrix(c(-54.5,-38.5, 2.5, -9.5, -45.5, 1.5, 9.5, 4.5, -10.5, -10.5), ncol=2)
fix <- matrix(c(-56.5, -30.5, -6.5, 14.5, -25.5, -48.5, 14.5, -2.5, 14.5,
               -11.5, -17.5, -11.5), ncol=2)
r <- rast()
ext(r) <- c(-110, 110, -45, 45)
r[] <- 1
set.seed(0)
sam <- spatSample(r, 50, xy=TRUE, as.points=TRUE)

plot(sam, pch='x')
points(ref, col='red', pch=18, cex=2)
points(fix, col='blue', pch=20, cex=2)

i <- pwd_sample(fix, sam, ref, lonlat=TRUE)
i
sfix <- fix[!is.na(i), ]
ssam <- sam[i[!is.na(i)], ]
ssam

plot(sam, pch='x', cex=0)
points(ssam, pch='x')
points(ref, col='red', pch=18, cex=2)
points(sfix, col='blue', pch=20, cex=2)

# try to get 3 pairs for each point in 'fixed'
pwd_sample(fix, sam, ref, lonlat=TRUE, n=3)
}

\keyword{spatial}

\name{SDM}

\docType{class}

\alias{SDM-class}

\title{Class "SDM"}

\description{
Parent class for a number of models defined in the predicts package. This is a virtual Class, no objects may be direclty created from it. 
}



\keyword{classes}

\name{threshold}

\alias{threshold}
\alias{threshold,paModelEvaluation-method}


\title{ Find a threshold }

\description{ 
Find a threshold (cut-off) to transform model predictions (probabilities, distances, or similar values) to a binary score (presence or absence). 
}

\usage{
\S4method{threshold}{paModelEvaluation}(x)
}
 
\arguments{
  \item{x}{paModelEvaluation object (see \code{\link{pa_evaluate}}}
}

\value{
data.frame with the following columns:

kappa: the threshold at which kappa is highest ("max kappa")

spec_sens: the threshold at which the sum of the sensitivity (true positive rate) and specificity (true negative rate) is highest

no_omission: the highest threshold at which there is no omission 

prevalence: modeled prevalence is closest to observed prevalence
		
equal_sens_spec: equal sensitivity and specificity
}

\author{
Robert J. Hijmans and Diego Nieto-Lugilde
}


\seealso{\code{\link{pa_evaluate}}}

\examples{
## See ?maxent for an example with real data.
# this is a contrived example:
# p has the predicted values for 50 known cases (locations)
# with presence of the phenomenon (species)
p <- rnorm(50, mean=0.7, sd=0.3)
# b has the predicted values for 50 background locations (or absence)
a <- rnorm(50, mean=0.4, sd=0.4)
e <- pa_evaluate(p=p, a=a)

threshold(e)
}

\keyword{spatial}

\name{biovars}

\docType{methods}

\alias{bcvars}
\alias{bcvars,matrix,matrix,matrix-method}
\alias{bcvars,SpatRaster,SpatRaster,SpatRaster-method}
\alias{bcvars,numeric,numeric,numeric-method}

\title{bioclimatic variables}

\description{
Function to create 'bioclimatic variables' from monthly climate data. 
}

\usage{
\S4method{bcvars}{SpatRaster,SpatRaster,SpatRaster}(prec, tmin, tmax, filename="", ...)

\S4method{bcvars}{numeric,numeric,numeric}(prec, tmin, tmax)

\S4method{bcvars}{matrix,matrix,matrix}(prec, tmin, tmax)
}

\arguments{
  \item{prec}{numeric vector (12 values), matrix (12 columns), or SpatRaster with monthly (12 layers) precipitation data}
  \item{tmin}{same as \code{prec}}
  \item{tmax}{same as \code{prec}}
  \item{filename}{character. Output filename}
  \item{...}{additional arguments for writing files as in \code{\link[terra]{writeRaster}}}
}

\details{
Input data is normally monthly. I.e. there should be 12 values (layers) for each variable, but the function should also work for e.g. weekly data (with some changes in the meaning of the output variables. E.g. #8 would then not be for a quarter (3 months), but for a 3 week period). 
}

\value{
Same class as input, but 19 values/variables

bio1 = Mean annual temperature

bio2 = Mean diurnal range (mean of max temp - min temp)

bio3 = Isothermality (bio2/bio7) (* 100)

bio4 = Temperature seasonality (standard deviation *100)

bio5 = Max temperature of warmest month

bio6 = Min temperature of coldest month

bio7 = Temperature annual range (bio5-bio6)

bio8 = Mean temperature of the wettest quarter

bio9 = Mean temperature of driest quarter 

bio10 = Mean temperature of warmest quarter

bio11 = Mean temperature of coldest quarter

bio12 = Total (annual) precipitation

bio13 = Precipitation of wettest month

bio14 = Precipitation of driest month

bio15 = Precipitation seasonality (coefficient of variation)

bio16 = Precipitation of wettest quarter

bio17 = Precipitation of driest quarter

bio18 = Precipitation of warmest quarter
}


\examples{
tmin <- c(10,12,14,16,18,20,22,21,19,17,15,12)
tmax <- tmin + 5
prec <- c(0,2,10,30,80,160,80,20,40,60,20,0)
bcvars(prec, tmin, tmax)

tmn <- tmx <- prc <- rast(nrow=1, ncol=1, nlyr=12)
values(tmn) <- t(matrix(c(10,12,14,16,18,20,22,21,19,17,15,12)))
tmx <- tmn + 5
values(prc) <- t(matrix(c(0,2,10,30,80,160,80,20,40,60,20,0)))
b <- bcvars(prc, tmn, tmx)
as.matrix(b)
}


\keyword{spatial}

\name{pycnophy}

\alias{pycnophy}

\title{
Pycnophylactic interpolation.
}

\description{
Given a \code{SpatVector} of polygons and population data for each polygon, compute a population density estimate based on Tobler's pycnophylactic interpolation algorithm.
}

\usage{
pycnophy(x, v, pop, r = 0.2, converge = 3, verbose=FALSE)
}

\arguments{
  \item{x}{SpatRaster to interpolate to}
  \item{v}{SpatVector of polygons}
  \item{pop}{Either a character (name in \code{v}) or a numeric vector of length \code{nrow(v)}}
  \item{r}{ A relaxation parameter for the iterative step in the pycnophylactic algorithm.  Prevents over-compensation in the smoothing step.  In practice the default value works well}
  \item{converge}{ A convergence parameter, informing the decision on when iterative improvements on the smooth surface have converged sufficiently - see details}
  \item{verbose}{If \code{TRUE} the function report the maximum change in any grid cell value for each iterative step}
}

\details{
This method uses an iterative approach, and for each iteration notes the maximum change in a pixel.  When this value falls below a certain level (10^(-converge) times the largest initial grid cell value) the iteration stops.  
}

\value{
SpatRaster 
}

\references{
Tobler, W.R. (1979) \emph{Smooth Pycnophylactic Interpolation for Geographical Regions}. Journal of the American Statistical Association, v74(367) pp. 519-530.
}

\author{
Chris Brunsdon (adapted for terra objects by Robert Hijmans)
}

\note{
Pycnophylatic interpolation has the property that the sum of the estimated values associated with all of the pixels in any polygon equals the supplied population for that polygon.  A further property is that all pixel values are greater than or equal to zero.  The method is generally used to obtain pixel-based population estimates when total populations for a set of irregular polygons (eg. counties) are known.
}

\examples{
f <- system.file("ex/lux.shp", package="terra")
v <- vect(f)
r <- rast(v, resolution = 0.01)
p <- pycnophy(r, v, "POP", converge=3, verbose=FALSE)
plot(p); lines(v)
}

\keyword{ smoothing }
\keyword{ spatial }

\name{pa_evaluate}

\alias{paModelEvaluation-class}

\alias{pa_evaluate}
\alias{plot,paModelEvaluation,ANY-method}


\title{Presence/absence Model evaluation }

\description{ 
Evaluation of models with presence/absence data. Given a vector of presence and a vector of absence values, confusion matrices are computed for a sequence of thresholds, and model evaluation statistics are computed for each confusion matrix / threshold. 
}

\usage{
pa_evaluate(p, a, model=NULL, x=NULL, tr, ...)
}
 
\arguments{
  \item{p}{either (1) predictions for presence points  (\code{model} is \code{NULL}); or (2) predictor values for presence points (\code{model} is not \code{NULL}, \code{x} is \code{NULL}; or locations for presence points (\code{model} and \code{x} are not \code{NULL})}   
  \item{a}{as above for absence or background points}
  \item{model}{A fitted model used to make predictions}
  \item{x}{SpatRaster used to extract predictor values from}
  \item{tr}{Optional. a vector of threshold values to use for computing the confusion matrices}
  \item{...}{Additional arguments passed on to \code{predict(model,...)}}
}

\value{
pa_ModelEvaluation object
}


\section{details}{

A pa_ModelEvaluation object has the the following slots 

\describe{
   \item{\code{presence}:}{presence values used }
   \item{\code{absence}:}{absence values used}
   \item{\code{confusion}:}{confusion matrix for each threshold}
   \item{\code{stats}:}{statistics that are not threshold dependent}
   \item{\code{tr_stats}:}{statistics that are threshold dependent}
   \item{\code{thresholds}:}{optimal thresholds to classify values into presence and absence}
}

\code{stats} has the following values
\describe{
    \item{\code{np}:}{number of presence points}
    \item{\code{na}:}{number of absence points}
    \item{\code{auc}:}{Area under the receiver operator (ROC) curve}
    \item{\code{pauc}:}{ p-value for the AUC (for the Wilcoxon test W statistic}
    \item{\code{cor}:}{ Correlation coefficient}
    \item{\code{pcor}:}{p-value for correlation coefficient }
    \item{\code{prevalence}:}{ Prevalence }
    \item{\code{ODP}:}{ Overall diagnostic power }
}

\code{tr_stats} has the following values
\describe{
    \item{\code{tresholds}:}{ vector of thresholds used to compute confusion matrices }
    \item{\code{CCR}:}{ Correct classification rate }
    \item{\code{TPR}:}{ True positive rate }
    \item{\code{TNR}:}{ True negative rate }
    \item{\code{FPR}:}{ False positive rate }
    \item{\code{FNR}:}{ False negative rate }
    \item{\code{PPP}:}{ Positive predictive power }
    \item{\code{NPP}:}{ Negative predictive power }
    \item{\code{MCR}:}{ Misclassification rate }
    \item{\code{OR}:}{ Odds-ratio }
    \item{\code{kappa}:}{ Cohen's kappa }
  }

\code{thresholds} has the following values
\describe{
	\item{\code{max_kappa}:}{the threshold at which kappa is highest}
	\item{\code{max_spec_sens}:}{the threshold at which the sum of the sensitivity (true positive rate) and specificity (true negative rate) is highest}
	\item{\code{no_omission}:}{the highest threshold at which there is no omission}
	\item{\code{prevalence}:}{modeled prevalence is closest to observed prevalence}
	\item{\code{equal_sens_spec}:}{equal sensitivity and specificity}
}
}


\references{
Fielding, A.H. and J.F. Bell, 1997. A review of methods for the assessment of prediction errors in conservation presence/absence models. Environmental Conservation 24:38-49

Liu, C., M. White & G. Newell, 2011. Measuring and comparing the accuracy of species distribution models with presence-absence data. Ecography 34: 232-243.
}


\seealso{\code{\link{cm_evaluate}}}


\examples{
set.seed(0)
# p has the predicted values for 50 known cases (locations) 
# with presence of the phenomenon (species)
p <- rnorm(50, mean=0.6, sd=0.3)
# a has the predicted values for 50 background locations (or absence)
a <- rnorm(50, mean=0.4, sd=0.4)

e <- pa_evaluate(p=p, a=a)
e

e@stats

plot(e, "ROC")
plot(e, "TPR")
plot(e, "boxplot")
plot(e, "density")

str(e)
}

\keyword{spatial}
